Class constructor($widget : cs:C1710.ImgWidget)
	
	This:C1470.widget:=$widget
	
	This:C1470.hierList:=0
	This:C1470.bookmarks:=Null:C1517
	
	This:C1470.isSetup:=False:C215
	
	This:C1470.itemRefSeed:=0
	
	
Function setup($bookmarks : Collection)
	
	This:C1470.cleanup()
	
	This:C1470.hierList:=This:C1470._buildHierList($bookmarks)
	This:C1470.bookmarks:=$bookmarks
	
	This:C1470.isSetup:=True:C214
	
	OB_ExecuteInSubform(This:C1470.widget.controlName; This:C1470; This:C1470._assignHierList)
	
	var $frameIdx : Integer
	$frameIdx:=ImgArea_GetFrameIndex:P11667:42(This:C1470.widget.areaRef)
	
	This:C1470.syncCurrentPage($frameIdx)
	
Function cleanup()
	
	If (This:C1470.hierList#0)
		CLEAR LIST:C377(This:C1470.hierList; *)
		This:C1470.hierList:=0
	End if 
	This:C1470.bookmarks:=Null:C1517
	
	This:C1470.isSetup:=False:C215
	
	OB_ExecuteInSubform(This:C1470.widget.controlName; This:C1470; This:C1470._assignHierList)
	
	
Function handleBookmarkSelection($itemRef : Integer)
	
	var $bookmark : Object
	$bookmark:=This:C1470.getBookmarkForItemRef($itemRef)
	If ($bookmark#Null:C1517)
		
		var $page : Integer
		$page:=This:C1470.getBookmarkPage($bookmark)
		
		This:C1470.widget.setFrameIndex($page)
		
	End if 
	
	
Function syncCurrentPage($targetPage : Integer)
	
	var $selectedPage : Integer
	$selectedPage:=0
	
	var $selectedItemRef : Integer
	$selectedItemRef:=Selected list items:C379(This:C1470.hierList; *)
	
	var $selectedBookmark : Object
	$selectedBookmark:=This:C1470.getBookmarkForItemRef($selectedItemRef)
	If ($selectedBookmark#Null:C1517)
		$selectedPage:=This:C1470.getBookmarkPage($selectedBookmark)
	End if 
	
	If ($targetPage#$selectedPage)
		
		var $targetItemRef : Integer
		$targetItemRef:=0
		
		var $targetBookmark : Object
		$targetBookmark:=This:C1470.getBookmarkForPage($targetPage)
		If ($targetBookmark#Null:C1517)
			$targetItemRef:=$targetBookmark["ItemRef"]
		End if 
		
		OB_ExecuteInSubform(This:C1470.widget.controlName; \
			This:C1470; This:C1470._selectListItem; New collection:C1472($targetItemRef))
		
	End if 
	
	
Function _selectListItem($itemRef : Integer)
	
	SELECT LIST ITEMS BY REFERENCE:C630(This:C1470.hierList; $itemRef)
	
	
Function getBookmarkForItemRef($itemRef : Integer)->$itemBookmark : Object
	
	$itemBookmark:=Null:C1517
	
	If ($itemRef#0)
		
		var $indexPath : Text
		GET LIST ITEM PARAMETER:C985(This:C1470.hierList; $itemRef; "IndexPath"; $indexPath)
		
		var $indexes : Collection
		$indexes:=Split string:C1554($indexPath; "/")
		If ($indexes.length>0)
			
			var $curIndex : Integer
			
			var $bookmarks : Collection
			$bookmarks:=This:C1470.bookmarks
			
			While ($indexes.length>1)
				$curIndex:=Num:C11($indexes.shift())
				$bookmarks:=$bookmarks[$curIndex]["Children"]
			End while 
			
			$curIndex:=Num:C11($indexes.pop())
			$itemBookmark:=$bookmarks[$curIndex]
			
		End if 
		
	End if 
	
	
Function getBookmarkForPage($page : Integer)->$bookmark : Object
	
	$bookmark:=This:C1470._getBookmarkForPage(This:C1470.bookmarks; $page)
	
	
Function _getBookmarkForPage($bookmarks : Collection; $page : Integer)->$bookmark : Object
	
	$bookmark:=Null:C1517
	
	If ($bookmarks#Null:C1517) & ($page>0)
		
		var $aBookmark : Object
		For each ($aBookmark; $bookmarks) While ($bookmark=Null:C1517)
			
			If (This:C1470.getBookmarkPage($aBookmark)=$page)
				$bookmark:=$aBookmark
			Else 
				If ($aBookmark["Children"]#Null:C1517)
					$bookmark:=This:C1470._getBookmarkForPage($aBookmark["Children"]; $page)
				End if 
			End if 
			
		End for each 
		
	End if 
	
	
Function getBookmarkPage($bookmark : Object)->$page : Integer
	
	$page:=0
	
	If ($bookmark#Null:C1517)
		
		var $action : Object
		$action:=$bookmark["Action"]
		If ($action#Null:C1517)
			
			Case of 
				: ($action["Type"]="GoTo")
					
					var $destination : Object
					$destination:=$action["Destination"]
					If ($destination#Null:C1517)
						
						var $page : Integer
						$page:=Num:C11($destination["Page"])
						
					End if 
					
			End case 
			
		End if 
		
	End if 
	
	
Function _assignHierList()  // In subform
	
	var $tocPtr : Pointer
	$tocPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "sidebar_toc")
	If (Not:C34(Is nil pointer:C315($tocPtr)))
		$tocPtr->:=This:C1470.hierList
	End if 
	
	
Function _buildHierList($bookmarks : Collection; $parentIndexPath : Collection)->$hierList : Integer
	
	$bookmarks:=Choose:C955($bookmarks#Null:C1517; $bookmarks; New collection:C1472())
	$parentIndexPath:=Choose:C955($parentIndexPath#Null:C1517; $parentIndexPath; New collection:C1472())
	
	$hierList:=New list:C375
	
	var $idx : Integer
	For ($idx; 0; $bookmarks.length-1)
		
		var $aBookmark : Object
		$aBookmark:=$bookmarks[$idx]
		
		var $itemIndexPath : Collection
		$itemIndexPath:=$parentIndexPath.copy()
		$itemIndexPath.push($idx)
		
		var $itemTitle : Text
		var $itemRef; $itemSubList : Integer
		
		This:C1470.itemRefSeed:=This:C1470.itemRefSeed+1
		$itemRef:=This:C1470.itemRefSeed
		$itemTitle:=$aBookmark["Title"]
		
		If ($aBookmark["Children"]#Null:C1517)
			
			var $itemSubList : Integer
			$itemSubList:=This:C1470._buildHierList($aBookmark["Children"]; $itemIndexPath)
			
			APPEND TO LIST:C376($hierList; $itemTitle; $itemRef; $itemSubList; False:C215)
			
		Else 
			APPEND TO LIST:C376($hierList; $itemTitle; $itemRef)
		End if 
		
		SET LIST ITEM PARAMETER:C986($hierList; $itemRef; "IndexPath"; $itemIndexPath.join("/"))
		
		$aBookmark["ItemRef"]:=$itemRef
		
	End for 
	
	