Class extends Part

Class constructor($spec : Object; $style : Object)
	
	Super:C1705("sidebar"; "sb_"; $spec; $style)
	
	This:C1470.width:=Choose:C955($spec.width#Null:C1517; $spec.width; 0)
	This:C1470.view:=Choose:C955($spec.view#Null:C1517; $spec.view; "thumbs")
	
Function validate()->$valid : Boolean
	
	$valid:=True:C214
	
	
Function effectivelyVisible()->$visible : Boolean
	
	$visible:=This:C1470.visible
	If ($visible)
		
		var $sidebarStyle; $splitterStyle : Object
		$sidebarStyle:=This:C1470.style.sidebar
		
		$visible:=(This:C1470.width>=$sidebarStyle.minWidth) & (This:C1470.width<=$sidebarStyle.maxWidth)
	End if 
	
	
Function layout($controlWidth : Integer; $controlHeight : Integer; \
$originX : Integer; $originY : Integer)
	
	var $sidebarStyle; $splitterStyle : Object
	$sidebarStyle:=This:C1470.style.sidebar
	$splitterStyle:=This:C1470.style.splitter
	
	If (This:C1470.width<=0)
		This:C1470.width:=$sidebarStyle.defaultWidth
	End if 
	If (This:C1470.width<$sidebarStyle.minWidth)
		This:C1470.width:=$sidebarStyle.minWidth
	End if 
	If (This:C1470.width>$sidebarStyle.maxWidth)
		This:C1470.width:=$sidebarStyle.maxWidth
	End if 
	
	var $sidebarVisible : Boolean
	$sidebarVisible:=This:C1470.effectivelyVisible()
	
	If ($sidebarVisible)
		This:C1470.bounds:=cs:C1710.Rect.new($originX; $originY; \
			This:C1470.width+1+This:C1470.style.splitter.width; $controlHeight-$originY)
	Else 
		This:C1470.bounds:=Null:C1517
	End if 
	
	
Function build()
	
	
Function apply()
	
	var $sidebarStyle; $splitterStyle : Object
	$sidebarStyle:=This:C1470.style.sidebar
	$splitterStyle:=This:C1470.style.splitter
	
	var $sidebarVisible : Boolean
	$sidebarVisible:=This:C1470.effectivelyVisible()
	
	OBJECT SET VISIBLE:C603(*; "sidebar_thumbs"; $sidebarVisible & (This:C1470.view="thumbs"))
	OBJECT SET VISIBLE:C603(*; "sidebar_toc"; $sidebarVisible & (This:C1470.view="TOC"))
	OBJECT SET VISIBLE:C603(*; "splitter"; $sidebarVisible)
	
	If ($sidebarVisible)
		
		var $left; $top; $right; $bottom : Integer
		$left:=This:C1470.bounds.x
		$top:=This:C1470.bounds.y+1
		$right:=$left+This:C1470.bounds.width-1-$splitterStyle.width
		$bottom:=$top+This:C1470.bounds.height-1
		
		OBJECT SET COORDINATES:C1248(*; "sidebar_thumbs"; $left; $top; $right; $bottom)
		OBJECT SET COORDINATES:C1248(*; "sidebar_toc"; $left; $top; $right; $bottom)
		
		//Splitter
		$left:=$right+1
		$right:=$left+$splitterStyle.width
		
		OBJECT SET COORDINATES:C1248(*; "splitter"; $left; $top; $right; $bottom)
		
	End if 
	
	
	
	
	
Function handleSplitterEvent($event : Object)->$shouldUpdate : Boolean
	
	var $left; $top; $right; $bottom : Integer
	OBJECT GET COORDINATES:C663(*; "splitter"; $left; $top; $right; $bottom)
	
	This:C1470.width:=$right-This:C1470.style.splitter.width-1
	
	var $sidebarVisible : Boolean
	$sidebarVisible:=This:C1470.effectivelyVisible()
	
	If ($sidebarVisible)
		This:C1470.bounds.width:=This:C1470.width
	End if 
	
	$shouldUpdate:=True:C214
	
	