Class constructor($widget : cs:C1710.ImgWidget)
	
	This:C1470.widget:=$widget
	This:C1470.widget.thumbnails:=New collection:C1472()
	
	This:C1470.builder:=cs:C1710.ThumbnailBuilder.new()
	
	
	This:C1470.currentThumbnailIndex:=-1
	This:C1470.currentThumbnail:=Null:C1517
	This:C1470.selectedThumbnails:=Null:C1517
	
	This:C1470.isSetup:=False:C215
	
Function setup()
	
	This:C1470.clear()
	
	This:C1470.isSetup:=True:C214
	
	var $cellSize : cs:C1710.Size
	$cellSize:=This:C1470.calcCellSize()
	
	This:C1470.builder.setup($cellSize.width; $cellSize.height; This:C1470.widget.style)
	
	This:C1470.widget.currentThumbnailIndex:=-1
	This:C1470.widget.currentThumbnail:=Null:C1517
	This:C1470.widget.selectedThumbnails:=Null:C1517
	
	var $areaRef : Integer
	$areaRef:=This:C1470.widget.areaRef
	
	var $docRef : Text
	$docRef:=ImgArea_GetDocument:P11667:41($areaRef)
	If ($docRef#"")
		
		
		var $frameCount; $frameIdx : Integer
		$frameCount:=ImgDoc_GetFrameCount:P11667:11($docRef)
		$frameIdx:=ImgArea_GetFrameIndex:P11667:42($areaRef)
		
		ImgObj_Release:P11667:133($docRef)
		
		This:C1470.widget.thumbnails.resize($frameCount; Null:C1517)
		
		var $idx : Integer
		For ($idx; 1; $frameCount)
			
			var $thumb : cs:C1710.Thumbnail
			$thumb:=This:C1470.builder.createGenericThumb($idx; ""; False:C215)
			
			This:C1470.widget.thumbnails[$idx-1]:=$thumb
			
		End for 
		
		//This.widget.thumbnails:=This.widget.thumbnails  // Force display update
		//OB_ExecuteInSubform(This.widget.controlName; This; This._updateThumbDisplay)
		
		//OB_ExecuteInSubform(This.widget.controlName; This; This._selectRow; New collection($frameIdx))
		
		This:C1470.syncCurrentThumb($frameIdx)
		
	End if 
	
	OB_ExecuteInSubform(This:C1470.widget.controlName; This:C1470; This:C1470._startTasking)
	
	
Function _resize()
	
	var $cellSize : cs:C1710.Size
	$cellSize:=This:C1470.calcCellSize()
	
	This:C1470.builder.setup($cellSize.width; $cellSize.height; This:C1470.widget.style)
	
	var $thumb : cs:C1710.Thumbnail
	For each ($thumb; This:C1470.widget.thumbnails)
		If ($thumb#Null:C1517)
			
			$thumb:=This:C1470.resizeThumbnail($thumb; $cellSize.width; $cellSize.height)
			$thumb.dirty:=True:C214
			
			This:C1470.widget.thumbnails[$thumb.index-1]:=$thumb
			
		End if 
	End for each 
	
	This:C1470._updateThumbDisplay()
	This:C1470._startTasking()
	
	
Function clear()
	
	This:C1470.widget.thumbnails.clear()
	This:C1470.isSetup:=False:C215
	
	
Function cleanup()
	
	This:C1470.clear()
	
	If (This:C1470.builder#Null:C1517)
		This:C1470.builder.cleanup()
		This:C1470.builder:=Null:C1517
	End if 
	
	
Function handleThumbnailSelection($targetFrame : Integer)
	
	var $areaRef : Integer
	$areaRef:=This:C1470.widget.areaRef
	
	var $currentFrame : Integer
	$currentFrame:=ImgArea_GetFrameIndex:P11667:42($areaRef)
	If ($targetFrame#$currentFrame)
		
		This:C1470.widget.setFrameIndex($targetFrame)
		
	End if 
	
	
Function syncCurrentThumb($frameIdx : Integer)
	
	This:C1470._selectRow($frameIdx)
	
	var $selectedThumbs : Collection
	$selectedThumbs:=This:C1470.widget.thumbnails.query("selected = :1"; True:C214)
	
	var $thumb; $newThumb : cs:C1710.Thumbnail
	
	For each ($thumb; $selectedThumbs)
		
		If ($thumb.imgData#Null:C1517)
			
			var $imgData : Blob
			BASE64 DECODE:C896($thumb.imgData; $imgData)
			
			$newThumb:=This:C1470.builder.createThumb($thumb.index; $thumb.label; False:C215; $imgData; $thumb.imgSize)
			
		Else 
			
			$newThumb:=This:C1470.builder.createGenericThumb($thumb.index; $thumb.label; False:C215)
			
		End if 
		
		This:C1470.widget.thumbnails[$thumb.index-1]:=$newThumb
		
	End for each 
	
	If ($frameIdx>0)
		
		$thumb:=This:C1470.widget.thumbnails[$frameIdx-1]
		If ($thumb.imgData#Null:C1517)
			
			var $imgData : Blob
			BASE64 DECODE:C896($thumb.imgData; $imgData)
			
			$newThumb:=This:C1470.builder.createThumb($thumb.index; $thumb.label; True:C214; $imgData; $thumb.imgSize)
			
		Else 
			
			$newThumb:=This:C1470.builder.createGenericThumb($thumb.index; $thumb.label; True:C214)
			
		End if 
		
		This:C1470.widget.thumbnails[$frameIdx-1]:=$newThumb
		
		OB_ExecuteInSubform(This:C1470.widget.controlName; This:C1470; This:C1470._autoScroll; New collection:C1472($frameIdx))
		
	End if 
	
	OB_ExecuteInSubform(This:C1470.widget.controlName; This:C1470; This:C1470._updateThumbDisplay)
	OB_ExecuteInSubform(This:C1470.widget.controlName; This:C1470; This:C1470._startTasking)
	
	
Function _autoScroll($row : Integer)
	
	Listbox_RevealRow("sidebar_thumbs"; $row)
	
	
Function _updateThumbDisplay()
	
	Form:C1466.thumbnails:=Form:C1466.thumbnails
	
	
Function _selectRow($rowIdx : Integer)
	
	LISTBOX SELECT ROW:C912(*; This:C1470.widget.controlName; $rowIdx; lk replace selection:K53:1)
	
	
Function calcCellSize()->$cellSize : cs:C1710.Size
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	var $style : cs:C1710.Style
	$style:=$widget.style
	
	var $sidebar : cs:C1710.Sidebar
	$sidebar:=$widget.sidebar
	
	var $builder : cs:C1710.ThumbnailBuilder
	$builder:=This:C1470.builder
	
	var $cellWidth; $cellHeight : Integer
	$cellWidth:=$sidebar.width-$style.scrollbarWidth
	$cellHeight:=$builder.calcCellHeight($cellWidth; $style)
	
	$cellSize:=cs:C1710.Size.new($cellWidth; $cellHeight)
	
	
Function _startTasking()
	
	SET TIMER:C645(1)
	
	
Function task()->$done : Boolean
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	var $sidebar : cs:C1710.Sidebar
	$sidebar:=$widget.sidebar
	
	C_LONGINT:C283($selectedFrame)
	$selectedFrame:=ImgArea_GetFrameIndex:P11667:42(This:C1470.widget.areaRef)
	
	var $idx0; $nullCount : Integer
	$nullCount:=0
	
	var $firstDirtyIdx0 : Integer
	$firstDirtyIdx0:=-1
	
	var $firstRow; $lastRow : Integer
	LB_GetVisibleRowRange("sidebar_thumbs"; ->$firstRow; ->$lastRow)
	
	If ($firstRow>0)
		
		var $thumb : cs:C1710.Thumbnail
		
		For ($idx0; $firstRow-1; $lastRow-1)
			$thumb:=This:C1470.widget.thumbnails[$idx0]
			If ($thumb=Null:C1517)
				$nullCount:=$nullCount+1
				$thumb:=This:C1470.builder.createGenericThumb($idx0+1; ""; ($idx0+1)=$selectedFrame)
				This:C1470.widget.thumbnails[$idx0]:=$thumb
			Else 
				If ($firstDirtyIdx0=-1)
					If ($thumb.dirty)
						$firstDirtyIdx0:=$idx0
					End if 
				End if 
			End if 
		End for 
		
	End if 
	
	Case of 
		: ($nullCount>0)
			
			//This.widget.thumbnails:=This.widget.thumbnails  // Force display update
			This:C1470._updateThumbDisplay()
			$done:=False:C215
			
		: ($firstDirtyIdx0>=0)
			
			var $newThumb : cs:C1710.Thumbnail
			$newThumb:=This:C1470.createThumbnail($firstDirtyIdx0+1; ($firstDirtyIdx0+1)=$selectedFrame)
			If ($newThumb=Null:C1517)
				$newThumb:=This:C1470.builder.createErrorThumb($firstDirtyIdx0+1; ""; ($firstDirtyIdx0+1)=$selectedFrame)
			End if 
			
			This:C1470.widget.thumbnails[$firstDirtyIdx0]:=$newThumb
			
			//This.widget.thumbnails:=This.widget.thumbnails  // Force display update
			This:C1470._updateThumbDisplay()
			
			$done:=False:C215
			
		Else 
			
			$done:=True:C214
			
	End case 
	
	
Function createThumbnail($index : Integer; $selected : Boolean)->$thumb : cs:C1710.Thumbnail
	
	var $maxSize : cs:C1710.Size
	$maxSize:=This:C1470.builder.maxPictSize()
	
	var $sizeOption : Object
	$sizeOption:=New object:C1471()
	$sizeOption["Width"]:=$maxSize.width
	$sizeOption["Height"]:=$maxSize.height
	
	var $options : Object
	$options:=New object:C1471()
	$options["Format"]:="JPEG"
	$options["MaxPixelSize"]:=$sizeOption
	
	var $pictData : Blob
	
	var $docRef : Text
	$docRef:=ImgArea_GetDocument:P11667:41(This:C1470.widget.areaRef)
	If ($docRef#"")
		
		$pictData:=ImgFrame_CreateThumb($docRef; $index; $options)
		
		ImgObj_Release:P11667:133($docRef)
	End if 
	
	If (BLOB size:C605($pictData)>0)
		
		var $pict : Picture
		BLOB TO PICTURE:C682($pictData; $pict)
		
		var $pictWidth; $pictHeight : Integer
		PICTURE PROPERTIES:C457($pict; $pictWidth; $pictHeight)
		
		$thumb:=This:C1470.builder.createThumb($index; ""; $selected; \
			$pictData; cs:C1710.Size.new($pictWidth; $pictHeight))
		
	End if 
	
	
Function resizeThumbnail($thumb : cs:C1710.Thumbnail; $width : Integer; $height : Integer)->$newThumb : cs:C1710.Thumbnail
	
	If ($thumb.imgData#Null:C1517)
		
		C_BLOB:C604($imgData)
		BASE64 DECODE:C896($thumb.imgData; $imgData)
		
		$newThumb:=This:C1470.builder.createThumb($thumb.index; $thumb.label; $thumb.selected; \
			$imgData; cs:C1710.Size.new($width; $height))
		
	Else 
		
		$newThumb:=This:C1470.builder.createGenericThumb($thumb.index; $thumb.label; $thumb.selected)
		
	End if 
	
	