//%attributes = {"invisible":true,"shared":true}
#DECLARE($actionName : Text; $message : Text; $context : cs:C1710.CallbackContext)->$status : Object

var $imgControl : cs:C1710.ImgWidget
$imgControl:=$context.imgControl

var $docRef; $docFormat : Text
$docRef:=$context.docRef
$docFormat:=$context.docFormat

$status:=New object:C1471

If ($docRef#"")
	
	var $filePath : Text
	$filePath:=ImgDoc_GetFilePath($docRef)
	
	Case of 
		: ($actionName="img_save")
			
			Case of 
				: ($message="status")
					
					var $needsSaving : Boolean
					
					If ($filePath#"")  // File-backed
						
						$needsSaving:=($context.docEdits#0)
						
					Else   // BLOB-backed or new
						
						var $dataSize : Integer
						$dataSize:=ImgDoc_GetDataSize($docRef)
						
						If ($dataSize>0)  // BLOB-backed
							$needsSaving:=True:C214
						Else 
							$needsSaving:=($context.frameCount>0)
						End if 
						
					End if 
					
					$status.enabled:=$needsSaving
					
				: ($message="action")
					
					var $docFormatInfo : Object
					$docFormatInfo:=ImgFormat_GetInfo($docFormat)
					
					var $savingOptions : Object
					var $promptDestFile; $promptSavingOptions : Boolean
					var $destPOSIXPath : Text
					
					If ($filePath#Null:C1517)
						
						If ($docFormatInfo.CanEncode)
							
							If ($imgControl.prefs.savingOptions#Null:C1517)
								
								$savingOptions:=OB Copy:C1225($imgControl.prefs.savingOptions)
								$promptSavingOptions:=False:C215
								
							Else 
								$savingOptions:=New object:C1471("Format"; $docFormat)
								$promptSavingOptions:=False:C215
							End if 
							
							$promptDestFile:=False:C215
							$destPOSIXPath:=$filePath
							
						Else 
							$savingOptions:=New object:C1471("Format"; $docFormat)  // Should be set to TIFF???
							$promptSavingOptions:=True:C214
							$promptDestFile:=True:C214
						End if 
						
					Else 
						$savingOptions:=New object:C1471("Format"; "TIFF")
						$promptSavingOptions:=True:C214
						$promptDestFile:=True:C214
					End if 
					
					//ImgCtlCtx_Save($imgControl; $docRef; $destPOSIXPath; $savingOptions; $promptSavingOptions; $promptDestFile)
					$imgControl._saveDoc($docRef; $destPOSIXPath; $savingOptions; $promptSavingOptions; $promptDestFile)
					
			End case 
			
		: ($actionName="img_save_as")
			
			Case of 
				: ($message="status")
					
					$status.enabled:=True:C214
					
				: ($message="action")
					
					var $savingOptions : Object
					var $promptDestFile; $promptSavingOptions : Boolean
					var $destPOSIXPath : Text
					
					If ($filePath#Null:C1517)
						
						$promptDestFile:=True:C214
						$promptSavingOptions:=True:C214
						
						If ($imgControl.prefs.savingOptions#Null:C1517)
							$savingOptions:=OB Copy:C1225($imgControl.prefs.savingOptions)
						Else 
							$savingOptions:=New object:C1471("Format"; $docFormat)
						End if 
						
					Else 
						$savingOptions:=New object:C1471("Format"; "TIFF")
						$promptSavingOptions:=True:C214
						$promptDestFile:=True:C214
					End if 
					
					//ImgCtlCtx_Save($imgControl; $docRef; $destPOSIXPath; $savingOptions; $promptSavingOptions; $promptDestFile)
					$imgControl._saveDoc($docRef; $destPOSIXPath; $savingOptions; $promptSavingOptions; $promptDestFile)
					
			End case 
			
	End case 
	
End if 
