//%attributes = {"invisible":true,"shared":true}
#DECLARE($actionName : Text; $message : Text; $context : cs:C1710.CallbackContext)->$status : Object

var $areaRef : Integer
$areaRef:=$context.areaRef

var $docRef : Text
$docRef:=$context.docRef

$status:=New object:C1471
$status.enabled:=False:C215

If ($docRef#"")
	
	var $zoomFactorRange : Object
	ImgArea_GetProperty($areaRef; "ZoomFactorRange"; ->$zoomFactorRange)
	
	var $zoomFactorMin; $zoomFactorMax : Real
	$zoomFactorMin:=OB Get:C1224($zoomFactorRange; "Minimum"; Is real:K8:4)
	$zoomFactorMax:=OB Get:C1224($zoomFactorRange; "Maximum"; Is real:K8:4)
	
	var $zoomToolRate : Real
	ImgArea_GetProperty($areaRef; "ZoomToolRate"; ->$zoomToolRate)
	
	var $zoomFactor : Real
	$zoomFactor:=ImgArea_GetZoomFactor:P11667:44($areaRef)
	
	var $autoZoom : Integer
	$autoZoom:=ImgArea_GetAutoZoom:P11667:54($areaRef)
	
	Case of 
		: ($message="status")
			
			Case of 
				: ($actionName="img_zoom_in")
					
					$status.enabled:=($zoomFactor<$zoomFactorMax)
					
				: ($actionName="img_zoom_out")
					
					$status.enabled:=($zoomFactor>$zoomFactorMin)
					
				: ($actionName="img_zoom_100")
					
					$status.enabled:=True:C214
					
				: ($actionName="img_zoom_fit")
					
					$status.enabled:=True:C214
					If ($autoZoom#0)
						$status.checked:=True:C214
					End if 
					
				: ($actionName="img_zoom_percent")
					
					$status.enabled:=True:C214
					$status.value:=$zoomFactor*100
					$status.minValue:=$zoomFactorMin*100
					$status.maxValue:=$zoomFactorMax*100
					
					var $decSep : Text
					GET SYSTEM FORMAT:C994(Decimal separator:K60:1; $decSep)
					
					var $displayValue : Text
					$displayValue:=String:C10($status.value; "###0.0")
					If (($displayValue="@.0") | ($displayValue=("@"+$decSep+"0")))
						$displayValue:=Substring:C12($displayValue; 1; Length:C16($displayValue)-2)
					End if 
					
					$status.displayValue:=$displayValue+"%"
					
			End case 
			
		: ($message="action")
			
			Case of 
				: ($actionName="img_zoom_in")
					
					$zoomFactor:=$zoomFactor*$zoomToolRate
					$zoomFactor:=Real_LimitToMinMax($zoomFactor; $zoomFactorMin; $zoomFactorMax)
					
					ImgArea_SetZoomFactor:P11667:45($areaRef; $zoomFactor)
					
				: ($actionName="img_zoom_out")
					
					$zoomFactor:=$zoomFactor/$zoomToolRate
					$zoomFactor:=Real_LimitToMinMax($zoomFactor; $zoomFactorMin; $zoomFactorMax)
					
					ImgArea_SetZoomFactor:P11667:45($areaRef; $zoomFactor)
					
				: ($actionName="img_zoom_100")
					
					ImgArea_SetZoomFactor:P11667:45($areaRef; 1)
					
				: ($actionName="img_zoom_fit")
					
					ImgArea_SetAutoZoom:P11667:55($areaRef; kImgAreaAutoZoomToFit | kImgAreaAutoZoomStretch | kImgAreaAutoZoomSticky)
					
				: ($actionName="img_zoom_percent")
					
					If ($context.args.value#Null:C1517)
						
						var $targetZoom : Real
						//$targetZoom:=Num($context.value)/100
						$targetZoom:=$context.args.value/100
						
						If (($targetZoom>=$zoomFactorMin) & ($targetZoom<=$zoomFactorMax))
							ImgArea_SetZoomFactor:P11667:45($areaRef; $targetZoom)
						End if 
						
					End if 
					
			End case 
			
	End case 
	
End if 
