//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$partName)  // @param: The name of the part.
C_BOOLEAN:C305($0;$isVisible)  // @param: The part's visibility.

  // @desc: Return the visibility of a ImgControl part.

  // @doc: Return the visibility of a part of the ``ImgControl`` named ``controlName``.
  //
  // The part name can be ``"Menubar"``, ``"Toolbar"``, or ``"Sidebar"``.
  //
  // The part's visibility is returned in ``isVisible``.
  //

ASSERT:C1129(Count parameters:C259=2)

$controlName:=$1
$partName:=$2
$isVisible:=False:C215

C_POINTER:C301($controlPtr)
$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$controlName)

ASSERT:C1129(Not:C34(Is nil pointer:C315($controlPtr)))
ASSERT:C1129(Type:C295($controlPtr->)=Is object:K8:27)

C_OBJECT:C1216($context)
$context:=$controlPtr->
If ($context#Null:C1517)
	$isVisible:=ImgCtlCtx_IsPartVisible ($context;$partName)
End if 

$0:=$isVisible
