//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$imgDocRef)  // @param: The image document reference
C_LONGINT:C283($3;$frameIdx)  // @param: The image frame index.
C_LONGINT:C283($0;$success)  // @param: Completion status: ``1`` on success, ``0`` otherwise.

  // @desc: Assign an image document to a ImgControl form object.

  // @doc: Assign an image document to the ``ImgControl`` form object named ``controlName``.
  //
  // The image document and frame to be assigned to the control are specified by ``imgDocRef``
  // and ``frameIdx`` respectively.
  //

ASSERT:C1129(Count parameters:C259>=2)

$controlName:=$1
$imgDocRef:=$2
If (Count parameters:C259>2)
	$frameIdx:=$3
End if 
If ($frameIdx=0)
	$frameIdx:=1
End if 
$success:=0


C_POINTER:C301($controlPtr)
$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$controlName)

ASSERT:C1129(Not:C34(Is nil pointer:C315($controlPtr)))
ASSERT:C1129(Type:C295($controlPtr->)=Is object:K8:27)

C_OBJECT:C1216($context)
$context:=$controlPtr->
If ($context#Null:C1517)
	
	C_LONGINT:C283($areaRef)
	$areaRef:=$context.areaRef
	
	C_TEXT:C284($areaName)
	$areaName:=$context.areaName
	
	
	
	  //OBJECT SET VISIBLE(*;$areaName;False)
	
	
	  // Just to check for an already assigned doc
	C_TEXT:C284($existingDoc)
	$existingDoc:=ImgArea_GetDocument:P11667:41 ($areaRef)
	If ($existingDoc#"")
		
		ImgArea_SetDocument:P11667:40 ($areaRef;"")  // Unload existing doc
		
		ImgCtlCtx_PostMessage ($context;New object:C1471("what";"ImageUnloaded"))
		
	End if 
	
	$success:=ImgArea_SetDocument:P11667:40 ($areaRef;$imgDocRef;$frameIdx)
	If ($success=1)
		
		ImgCtlCtx_PostMessage ($context;New object:C1471("what";"ImageLoaded"))
		
	End if 
	
	If ($existingDoc#"")
		  // Was retained with the ImgArea_GetDocument() call above
		ImgObj_Release:P11667:133 ($existingDoc)
	End if 
	
	  //$message:=OB_New 
	  //OB SET($message;"what";"_show_area")
	  //Queue_PostMessage ($context;$message)
	
	ImgCtlCtx_UpdateState ($context)
	
End if 

$0:=$success
