//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$sidebarView)  // @param: The name of the sidebar view.

  // @desc: Set the view of the sidebar.

  // @doc: Set the sidebar view of the
  // ``ImgControl`` named ``controlName``.
  //
  // The sidebar view is specified in ``sidebarView``.
  // May be either ``"thumbs"`` or ``"TOC"``.
  //

ASSERT:C1129(Count parameters:C259=2)

$controlName:=$1
$sidebarView:=$2

C_POINTER:C301($controlPtr)
$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$controlName)

ASSERT:C1129(Not:C34(Is nil pointer:C315($controlPtr)))
ASSERT:C1129(Type:C295($controlPtr->)=Is object:K8:27)

C_OBJECT:C1216($context)
$context:=$controlPtr->
If ($context#Null:C1517)
	
	C_OBJECT:C1216($config)
	$config:=$context.config
	
	If (($config#Null:C1517)\
		 & (($sidebarView="thumbs") | ($sidebarView="TOC"))\
		)
		
		If ($config.sidebar.view#$sidebarView)
			
			$config.sidebar.view:=$sidebarView
			
			C_BOOLEAN:C305($applied)
			EXECUTE METHOD IN SUBFORM:C1085($controlName;"ImgCtlNG_ApplyLayout_Sidebar";$applied;$context.layout.sidebar;$config;$context.metrics)
			
		End if 
		
	End if 
	
End if 
