//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.

  // @desc: Update the layout of a ImgControl form object.

  // @doc: Update the layout of the ``ImgControl`` form object named ``controlName``.
  //
  // If the ``ImgControl`` object has any of its resizing options set to either *grow* or *move*,
  // it has to be notified of form resize events in order to update the layout of its parts.
  // To do that, this method **must** be called from the host form method during the ``On Resize``
  // event.
  //
  //

ASSERT:C1129(Count parameters:C259=1)

$controlName:=$1

C_POINTER:C301($contextPtr)
$contextPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$controlName)
If (Not:C34(Is nil pointer:C315($contextPtr)))
	
	C_OBJECT:C1216($context)
	$context:=$contextPtr->
	
	If ($context#Null:C1517)
		
		C_LONGINT:C283($left;$top;$right;$bottom)
		OBJECT GET COORDINATES:C663(*;$controlName;$left;$top;$right;$bottom)
		
		C_LONGINT:C283($controlWidth;$controlHeight)
		$controlWidth:=$right-$left
		$controlHeight:=$bottom-$top
		
		ImgCtlNG_UpdateLayout ($context.config;$context.layout;$context.metrics;$controlWidth;$controlHeight)
		$context.state.layoutUpdated:=True:C214
		
		C_LONGINT:C283($currentPage)
		$currentPage:=FORM Get current page:C276
		
		If (($context.formPage=0) | ($context.formPage=$currentPage))
			
			C_BOOLEAN:C305($applied)
			EXECUTE METHOD IN SUBFORM:C1085($controlName;"ImgCtlNG_ApplyLayout";$applied;$context.layout;$context.config;$context.metrics)
			$context.state.layoutApplied:=$applied
			
			ImgCtlCtx_UpdateState ($context)
			
		Else 
			$context.state.layoutApplied:=False:C215
		End if 
		
		ImgCtlNG_ApplyLayout_PlugArea ($context)
		
	End if 
	
End if 

