//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$partName)  // @param: The name of the part.
C_BOOLEAN:C305($0;$isVisible)  // @param: The part's visibility.

  // @desc: Return the visibility of a ImgControl part.

  // @doc: Return the visibility of a part of the ``ImgControl`` named ``controlName``.
  //
  // The part name can be ``"Menubar"``, ``"Toolbar"``, or ``"Sidebar"``.
  //
  // The part's visibility is returned in ``isVisible``.
  //

ASSERT:C1129(Count parameters:C259=2)

$controlName:=$1
$partName:=$2
$isVisible:=False:C215

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_TEXT:C284($propName)
	Case of 
		: ($partName="Menubar")
			$propName:="_menubar_visible"
		: ($partName="Toolbar")
			$propName:="_toolbar_visible"
		: ($partName="sidebar")
			$propName:="_sidebar_visible"
		Else 
			$propName:=""
	End case 
	
	If ($propName#"")
		$isVisible:=OB Get:C1224($context;$propName;Is boolean:K8:9)
	End if 
	
End if 

$0:=$isVisible
