//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$imgDocRef)  // @param: The image document reference
C_LONGINT:C283($3;$frameIdx)  // @param: The image frame index.
C_LONGINT:C283($0;$success)  // @param: Completion status: ``1`` on success, ``0`` otherwise.

  // @desc: Assign an image document to a ImgControl form object.

  // @doc: Assign an image document to the ``ImgControl`` form object named ``controlName``.
  //
  // The image document and frame to be assigned to the control are specified by ``imgDocRef``
  // and ``frameIdx`` respectively.
  //

ASSERT:C1129(Count parameters:C259>=2)

$controlName:=$1
$imgDocRef:=$2
If (Count parameters:C259>2)
	$frameIdx:=$3
End if 
If ($frameIdx=0)
	$frameIdx:=1
End if 
$success:=0

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_LONGINT:C283($areaRef)
	$areaRef:=OB Get:C1224($context;"_area_ref";Is longint:K8:6)
	
	C_TEXT:C284($areaName)
	$areaName:=OB Get:C1224($context;"_area_name";Is text:K8:3)
	
	  //C_BOOLEAN($isVisible)
	  //$isVisible:=OBJECT Get visible(*;$areaName)
	
	OBJECT SET VISIBLE:C603(*;$areaName;False:C215)
	
	C_OBJECT:C1216($message)
	
	  // Just to check for an already assigned doc
	C_TEXT:C284($existingDoc)
	$existingDoc:=ImgArea_GetDocument:P11667:41 ($areaRef)
	If ($existingDoc#"")
		
		ImgArea_SetDocument:P11667:40 ($areaRef;"")  // Unload existing doc
		
		  // Post unload message
		$message:=OB_New 
		OB SET:C1220($message;"what";"ImageUnloaded")
		Queue_PostMessage ($context;$message)
		
	End if 
	
	OB REMOVE:C1226($context;"_format_info")
	
	$success:=ImgArea_SetDocument:P11667:40 ($areaRef;$imgDocRef;$frameIdx)
	If ($success=1)
		
		  // Update format info
		
		C_TEXT:C284($format)
		$format:=ImgDoc_GetFormat:P11667:9 ($imgDocRef)
		
		C_OBJECT:C1216($formatInfo)
		$formatInfo:=ImgFormat_GetInfo ($format)
		
		If (OB Is defined:C1231($formatInfo))
			OB SET:C1220($context;"_format_info";$formatInfo)
		End if 
		
		  // Post load message
		$message:=OB_New 
		OB SET:C1220($message;"what";"ImageLoaded")
		Queue_PostMessage ($context;$message)
		
	End if 
	
	If ($existingDoc#"")
		  // Was retained with the ImgArea_GetDocument() call above
		ImgObj_Release:P11667:133 ($existingDoc)
	End if 
	
	$message:=OB_New 
	OB SET:C1220($message;"what";"_show_area")
	Queue_PostMessage ($context;$message)
	
	ImgControl_UpdateState ($controlName)
	
End if 

$0:=$success
