//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_LONGINT:C283($2;$frameIdx)  // @param: The image frame index.
C_LONGINT:C283($0;$success)  // @param: Completion status: ``1`` on success, ``0`` otherwise.

  // @desc: Change the image frame displayed in a ImgControl form object.

  // @doc: Change the image frame displayed in the ``ImgControl`` form object named ``controlName``.
  //
  // The image frame index is specified by ``frameIdx``.
  //

ASSERT:C1129(Count parameters:C259>=1)

$controlName:=$1
If (Count parameters:C259>1)
	$frameIdx:=$2
End if 
If ($frameIdx=0)
	$frameIdx:=1
End if 
$success:=0

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_LONGINT:C283($areaRef)
	$areaRef:=OB Get:C1224($context;"_area_ref";Is longint:K8:6)
	
	$success:=ImgArea_SetFrameIndex:P11667:43 ($areaRef;$frameIdx)
	
	C_OBJECT:C1216($message)
	OB SET:C1220($message;"what";"UpdateState")
	ImgControl_PostMessage ($controlName;$message)
	
	OB SET:C1220($message;"what";"FrameIndex")
	ImgControl_PostMessage ($controlName;$message)
	
End if 

$0:=$success
