//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$imageFilePath)  // @param: The full path to the image file.
C_LONGINT:C283($0;$success)  // @param: Completion status: ``1`` on success, ``0`` otherwise.

  // @desc: Assign an image file to an ImgControl form object.

  // @doc: Assign an image file to the ``ImgControl`` form object named ``controlName``.
  //
  // Parameter ``imageFilePath`` is the full (absolute) pathname to the image file. The pathname
  // may be in either POSIX (recommended) or System format.
  //
  // Handling of the file selection dialog (when ``imageFilePath`` is empty) and password entry
  // for protected PDF's is delegated to :cc4d:cmethod:`ImgDoc_CreateWithFile`.
  //

ASSERT:C1129(Count parameters:C259>=1)

$controlName:=$1
If (Count parameters:C259>1)
	$imageFilePath:=$2
End if 
$success:=0

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_TEXT:C284($imgDocRef)
	$imgDocRef:=ImgDoc_CreateWithFile ($imageFilePath)
	If ($imgDocRef#"")
		
		$success:=ImgControl_SetDocument ($controlName;$imgDocRef)
		
		ImgObj_Release:P11667:133 ($imgDocRef)
		
	End if 
	
End if 

$0:=$success
