//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$partName)  // @param: The name of the part.
C_BOOLEAN:C305($3;$visible)  // @param: The part's visibility.

  // @desc: Set the visibility of a ImgControl part.

  // @doc: Set the visibility of a part of the ``ImgControl`` named ``controlName``.
  //
  // The part name can be ``"Menubar"``, ``"Toolbar"``, or ``"Sidebar"``.
  //
  // The part's visibility is specified in ``isVisible``.
  //

ASSERT:C1129(Count parameters:C259=3)

$controlName:=$1
$partName:=$2
$visible:=$3

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_TEXT:C284($propName)
	Case of 
		: ($partName="Menubar")
			$propName:="_menubar_visible"
		: ($partName="Toolbar")
			$propName:="_toolbar_visible"
		: ($partName="sidebar")
			$propName:="_sidebar_visible"
		Else 
			$propName:=""
	End case 
	
	If ($propName#"")
		
		C_BOOLEAN:C305($currentlyVisible)
		$currentlyVisible:=OB Get:C1224($context;$propName;Is boolean:K8:9)
		If ($visible#$currentlyVisible)
			
			OB SET:C1220($context;$propName;$visible)
			
			ImgControl_UpdateLayout ($controlName)
			
		End if 
		
	End if 
	
End if 
