//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_POINTER:C301($2;$pictPtr)  // @param: Pointer to the picture.
C_LONGINT:C283($0;$success)  // @param: Completion status: ``1`` on success, ``0`` otherwise.

  // @desc: Assign a picture to a ImgControl form object.

  // @doc: Assign a picture to the ``ImgControl`` form object named ``controlName``.
  //
  // Parameter ``pictPtr`` a pointer to the picture.

ASSERT:C1129(Count parameters:C259=2)

$controlName:=$1
$pictPtr:=$2
$success:=0

ASSERT:C1129(Not:C34(Is nil pointer:C315($pictPtr)))
ASSERT:C1129(Type:C295($pictPtr->)=Is picture:K8:10)

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_TEXT:C284($imgDocRef)
	$imgDocRef:=ImgDoc_CreateWithPicture ($pictPtr)
	If ($imgDocRef#"")
		
		$success:=ImgControl_SetDocument ($controlName;$imgDocRef)
		
		ImgObj_Release:P11667:133 ($imgDocRef)
		
	End if 
	
End if 

$0:=$success


