//%attributes = {}
C_OBJECT:C1216($1;$config)
C_OBJECT:C1216($0;$validConfig)

$config:=$1
$validConfig:=OB Copy:C1225($config)

C_OBJECT:C1216($commands;$menubar;$toolbar;$sidebar)
$commands:=Choose:C955($config.commands#Null:C1517;$config.commands;New object:C1471)
$menubar:=Choose:C955($config.menubar#Null:C1517;$config.menubar;New object:C1471)
$toolbar:=Choose:C955($config.toolbar#Null:C1517;$config.toolbar;New object:C1471)
$sidebar:=Choose:C955($config.sidebar#Null:C1517;$config.sidebar;New object:C1471)


C_OBJECT:C1216($validCommands;$validMenubar;$validToolbar;$validSidebar)
$validCommands:=New object:C1471
$validMenubar:=New object:C1471
$validToolbar:=New object:C1471
$validSidebar:=New object:C1471

C_OBJECT:C1216($aCommand)
C_TEXT:C284($commandID)

For each ($commandID;$commands)
	
	C_TEXT:C284($methodName)
	$methodName:=$commands[$commandID].method
	
	C_OBJECT:C1216($methodCheck)
	$methodCheck:=ImgCtlNG_CheckMethod ($methodName)
	
	If ($methodCheck.exists)
		
		If ($methodCheck.shared)
			
			$validCommands[$commandID]:=$commands[$commandID]
			
		Else 
			
			If (Not:C34(Is compiled mode:C492(*)))
				ALERT:C41(\
					"[ImgCtl]\n\nProject method '"+$methodName\
					+"' which is registered for handling command '"+$commandID\
					+"' was not found in either the Q2ImgControl component or the host database.")
			End if 
			
		End if 
		
	Else 
		
		If (Not:C34(Is compiled mode:C492(*)))
			ALERT:C41(\
				"[ImgCtl]\n\nProject method '"+$methodName\
				+"' which is registered for handling command '"+$commandID\
				+"' was not found in either the Q2ImgControl component or the host database.")
		End if 
		
	End if 
	
End for each 

$validMenubar.visible:=Choose:C955($menubar.visible#Null:C1517;Bool:C1537($menubar.visible);True:C214)
$validMenubar.menus:=New collection:C1472

C_OBJECT:C1216($menu)
C_LONGINT:C283($menuIdx)
For ($menuIdx;0;$menubar.menus.length-1)
	
	$menu:=$menubar.menus[$menuIdx]
	
	C_OBJECT:C1216($validMenu)
	$validMenu:=New object:C1471
	$validMenu.visible:=Choose:C955($menu.visible#Null:C1517;Bool:C1537($menu.visible);True:C214)
	$validMenu.title:=$menu.title
	$validMenu.items:=New collection:C1472
	
	C_LONGINT:C283($itemIdx)
	For ($itemIdx;0;$menu.items.length-1)
		
		Case of 
			: (Value type:C1509($menu.items[$itemIdx])=Is text:K8:3)
				
				C_TEXT:C284($itemText)
				$itemText:=$menu.items[$itemIdx]
				
				If ($itemText="-")
					
					C_OBJECT:C1216($validItem)
					$validItem:=New object:C1471
					
					$validItem.title:="-"
					$validMenu.items.push($validItem)
					
				Else 
					
					If ($itemText#"")
						
						If ($validCommands[$itemText]#Null:C1517)
							
							C_OBJECT:C1216($validItem)
							$validItem:=New object:C1471
							
							$validItem.command:=$itemText
							$validMenu.items.push($validItem)
							
						Else 
							
							If (Not:C34(Is compiled mode:C492(*)))
								ALERT:C41("[ImgCtl]\n\nCommand '"+$itemText+"' which is referenced from menu '"+$menu.title+"' is not defined.")
								TRACE:C157
							End if 
							
						End if 
						
					End if 
					
				End if 
				
				
			: (Value type:C1509($menu.items[$itemIdx])=Is object:K8:27)
				
				C_OBJECT:C1216($item)
				$item:=$menu.items[$itemIdx]
				
				If ($item.title="-")
					
					C_OBJECT:C1216($validItem)
					$validItem:=New object:C1471
					
					$validItem.title:="-"
					$validMenu.items.push($validItem)
					
				Else 
					
					If ($item.command#Null:C1517)
						
						If ($validCommands[$item.command]#Null:C1517)
							
							C_OBJECT:C1216($validItem)
							$validItem:=New object:C1471
							
							$validItem.command:=$item.command
							$validMenu.items.push($validItem)
							
						Else 
							
							If (Not:C34(Is compiled mode:C492(*)))
								ALERT:C41("[ImgCtl]\n\nCommand '"+$item.command+"' which is referenced from menu '"+$menu.title+"' is not defined.")
								TRACE:C157
							End if 
							
						End if 
						
					Else 
						
						  //If (Not(Is compiled mode(*)))
						  //ALERT("[ImgCtl]\n\nCommand '"+$itemText+"' which is referenced from menu '"+$menu.title+"' is not defined.")
						  //TRACE
						  //End if 
						
					End if 
					
				End if 
				
				
		End case 
		
	End for 
	
	If ($validMenu.items.length>0)
		$validMenubar.menus.push($validMenu)
	End if 
	
End for 


$validToolbar.visible:=Choose:C955($toolbar.visible#Null:C1517;Bool:C1537($toolbar.visible);True:C214)
$validToolbar.toolsets:=New collection:C1472

C_OBJECT:C1216($toolset)
C_LONGINT:C283($toolsetIdx)
For ($toolsetIdx;0;$toolbar.toolsets.length-1)
	
	$toolset:=$toolbar.toolsets[$toolsetIdx]
	
	C_OBJECT:C1216($validToolset)
	$validToolset:=New object:C1471
	$validToolset.visible:=Choose:C955($toolset.visible#Null:C1517;Bool:C1537($toolset.visible);True:C214)
	$validToolset.name:=$toolset.name
	$validToolset.tools:=New collection:C1472
	
	C_LONGINT:C283($toolIdx)
	For ($toolIdx;0;$toolset.tools.length-1)
		
		  //C_TEXT($toolText)
		  //$toolText:=$toolset.tools[$toolIdx]
		
		  //If (($toolText="") | (Not(OB Is defined($commands;$toolText))))
		
		  //If (Not(Is compiled mode(*)))
		  //ALERT("[ImgCtl]\n\nCommand '"+$toolText+"' which is referenced from toolset '"+$toolset.name+"' is not defined.")
		  //TRACE
		  //End if 
		
		  //$toolset.tools.remove($toolIdx)
		
		  //End if 
		
		
		
		
		Case of 
			: (Value type:C1509($toolset.tools[$toolIdx])=Is text:K8:3)
				
				C_TEXT:C284($toolText)
				$toolText:=$toolset.tools[$toolIdx]
				
				If ($toolText#"")
					
					If ($validCommands[$toolText]#Null:C1517)
						
						C_OBJECT:C1216($validTool)
						$validTool:=New object:C1471
						
						$validTool.command:=$toolText
						$validToolset.tools.push($validTool)
						
					Else 
						
						If (Not:C34(Is compiled mode:C492(*)))
							ALERT:C41("[ImgCtl]\n\nCommand '"+$toolText+"' which is referenced from toolset '"+$toolset.name+"' is not defined.")
							TRACE:C157
						End if 
						
					End if 
					
				End if 
				
				
			: (Value type:C1509($toolset.tools[$toolIdx])=Is object:K8:27)
				
				C_OBJECT:C1216($tool)
				$tool:=$toolset.tools[$toolIdx]
				
				If ($tool.command#Null:C1517)
					
					If ($validCommands[$tool.command]#Null:C1517)
						
						C_OBJECT:C1216($validTool)
						$validTool:=New object:C1471
						
						$validTool.command:=$tool.command
						
						If ($tool.items#Null:C1517)
							
							C_COLLECTION:C1488($toolItems)
							$toolItems:=New collection:C1472()
							
							C_VARIANT:C1683($item)
							For each ($item;$tool.items)
								
								Case of 
									: (Value type:C1509($item)=Is text:K8:3)
										
										C_TEXT:C284($itemText)
										$itemText:=$item
										
										If ($itemText="-")
											
											C_OBJECT:C1216($validItem)
											$validItem:=New object:C1471
											$validItem.title:="-"
											
											$toolItems.push($validItem)
											
										Else 
											
											If ($validCommands[$itemText]#Null:C1517)
												
												C_OBJECT:C1216($validItem)
												$validItem:=New object:C1471
												
												$validItem.command:=$itemText
												$validItem.title:=$validCommands[$itemText].title
												
												$toolItems.push($validItem)
												
											Else 
												
												If (Not:C34(Is compiled mode:C492(*)))
													ALERT:C41("[ImgCtl]\n\nCommand '"+$itemText+"' which is referenced from tool '"+$tool.title+"' is not defined.")
													TRACE:C157
												End if 
												
											End if 
											
										End if 
										
								End case 
								
							End for each 
							
							If ($toolItems.length>0)
								$validTool.items:=$toolItems
							End if 
							
						End if 
						
						$validToolset.tools.push($validTool)
						
					Else 
						
						If (Not:C34(Is compiled mode:C492(*)))
							ALERT:C41("[ImgCtl]\n\nCommand '"+$tool.command+"' which is referenced from toolset '"+$toolset.name+"' is not defined.")
							TRACE:C157
						End if 
						
					End if 
					
				Else 
					
					  //If (Not(Is compiled mode(*)))
					  //ALERT("[ImgCtl]\n\nCommand '"+$itemText+"' which is referenced from menu '"+$menu.title+"' is not defined.")
					  //TRACE
					  //End if 
					
				End if 
				
				
				
		End case 
		
	End for 
	
	If ($validToolset.tools.length>0)
		$validToolbar.toolsets.push($validToolset)
	End if 
	
End for 

$validSidebar.visible:=Choose:C955($sidebar.visible#Null:C1517;Bool:C1537($sidebar.visible);False:C215)
$validSidebar.view:="thumbs"

$validConfig:=New object:C1471("commands";$validCommands;"menubar";$validMenubar;"toolbar";$validToolbar;"sidebar";$validSidebar)

$0:=$validConfig

