Class constructor($pixelSize : Object; $dpiSize : Object)
	
	This:C1470.pixelSize:=$pixelSize
	This:C1470.dpiSize:=$dpiSize
	This:C1470.window:=0
	
	This:C1470.resample:=False:C215
	This:C1470.proportionalSizeValue:=0x0000
	This:C1470.proportionalResolutionValue:=0x0000
	This:C1470.proportionalBothValue:=0x0000
	
	This:C1470.noResampleUnits:=New collection:C1472("Points")
	This:C1470.resampleUnits:=New collection:C1472("Pixels"; "Points")
	
	This:C1470.unitsPopup:=New object:C1471()
	This:C1470.unitsPopup.values:=New collection:C1472()
	This:C1470.unitsPopup.index:=-1
	
	This:C1470.units:=""
	This:C1470.pixelWidth:=0
	This:C1470.pixelHeight:=0
	This:C1470.pointWidth:=0
	This:C1470.pointHeight:=0
	//This.percentWidth:=0
	//This.percentHeight:=0
	
	This:C1470.dpiWidth:=0
	This:C1470.dpiHeight:=0
	
	This:C1470.currentPixels:=""
	This:C1470.currentPoints:=""
	This:C1470.currentDPI:=""
	
	This:C1470.resultPixels:=""
	This:C1470.resultPoints:=""
	This:C1470.resultDPI:=""
	
	
Function runDialog()->$success : Boolean
	
	This:C1470.window:=Open form window:C675("_RasterSize"; Movable form dialog box:K39:8; \
		Horizontally centered:K39:1; Vertically centered:K39:4)
	SET WINDOW TITLE:C213("Adjust image size"; This:C1470.window)
	
	DIALOG:C40("_RasterSizeNG"; This:C1470)
	$success:=(OK=1)
	
	CLOSE WINDOW:C154(This:C1470.window)
	
	
Function handleFormEvent($event : Object)
	
	Case of 
		: ($event.code=On Load:K2:1)
			
			This:C1470.reset()
			This:C1470.updateCurrentSize()
			This:C1470.updateResultSize()
			This:C1470.validate()
			
	End case 
	
	
Function handleControlEvent($event : Object)
	
	Case of 
		: ($event.objectName="size_units")
			
			This:C1470.updateSizeValues()
			This:C1470.updateResultSize()
			
		: ($event.objectName="pixel_width")
			
			var $pixelWidth : Integer
			If ($event.code=On After Edit:K2:43)
				$pixelWidth:=Num:C11(Get edited text:C655)
			Else 
				$pixelWidth:=This:C1470.pixelWidth
			End if 
			
			C_POINTER:C301($propSizePtr)
			$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
			
			C_BOOLEAN:C305($propSize)
			$propSize:=($propSizePtr->=1)
			
			If ($pixelWidth>0)
				
				If ($propSize)
					
					C_REAL:C285($originalPixelWidth; $originalPixelHeight)
					$originalPixelWidth:=SizeObj_GetWidth(This:C1470.pixelSize)
					$originalPixelHeight:=SizeObj_GetHeight(This:C1470.pixelSize)
					
					This:C1470.pixelHeight:=$originalPixelHeight*($pixelWidth/$originalPixelWidth)
					
				End if 
				
				This:C1470.updateResultSize()
				
			End if 
			
			This:C1470.validate()
			
		: ($event.objectName="pixel_height")
			
			var $pixelHeight : Integer
			If ($event.code=On After Edit:K2:43)
				$pixelHeight:=Num:C11(Get edited text:C655)
			Else 
				$pixelHeight:=This:C1470.pixelHeight
			End if 
			
			C_POINTER:C301($propSizePtr)
			$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
			
			C_BOOLEAN:C305($propSize)
			$propSize:=($propSizePtr->=1)
			
			If ($pixelHeight>0)
				
				If ($propSize)
					
					C_REAL:C285($originalPixelWidth; $originalPixelHeight)
					$originalPixelWidth:=SizeObj_GetWidth(This:C1470.pixelSize)
					$originalPixelHeight:=SizeObj_GetHeight(This:C1470.pixelSize)
					
					This:C1470.pixelWidth:=$originalPixelWidth*($pixelHeight/$originalPixelHeight)
					
				End if 
				
				This:C1470.updateResultSize()
				
			End if 
			
			This:C1470.validate()
			
		: ($event.objectName="point_width")
			
			var $pointWidth : Real
			If ($event.code=On After Edit:K2:43)
				$pointWidth:=Num:C11(Get edited text:C655)
			Else 
				$pointWidth:=This:C1470.pointWidth
			End if 
			
			If ($pointWidth>0)
				
				If (This:C1470.resample)
					
					var $pixelWidth : Integer
					$pixelWidth:=($pointWidth*This:C1470.dpiWidth)/72
					This:C1470.pixelWidth:=$pixelWidth
					
					If ($event.code=On Data Change:K2:15)
						This:C1470.pointWidth:=(This:C1470.pixelWidth/This:C1470.dpiWidth)*72
					End if 
					
					C_POINTER:C301($propSizePtr)
					$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
					
					C_BOOLEAN:C305($propSize)
					$propSize:=($propSizePtr->=1)
					If ($propSize)
						
						C_REAL:C285($originalPixelWidth; $originalPixelHeight)
						$originalPixelWidth:=SizeObj_GetWidth(This:C1470.pixelSize)
						$originalPixelHeight:=SizeObj_GetHeight(This:C1470.pixelSize)
						
						This:C1470.pixelHeight:=$originalPixelHeight*($pixelWidth/$originalPixelWidth)
						This:C1470.pointHeight:=(This:C1470.pixelHeight/This:C1470.dpiHeight)*72
						
					End if 
					
				Else 
					
					This:C1470.dpiWidth:=(This:C1470.pixelWidth*72)/$pointWidth
					
					If ($event.code=On Data Change:K2:15)
						This:C1470.pointWidth:=(This:C1470.pixelWidth/This:C1470.dpiWidth)*72
					End if 
					
					C_POINTER:C301($propResPtr)
					$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
					
					C_BOOLEAN:C305($propRes)
					$propRes:=($propResPtr->=1)
					If ($propRes)
						
						C_REAL:C285($originalDPIWidth; $originalDPIHeight)
						$originalDPIWidth:=SizeObj_GetWidth(This:C1470.dpiSize)
						$originalDPIHeight:=SizeObj_GetHeight(This:C1470.dpiSize)
						
						This:C1470.dpiHeight:=$originalDPIHeight*(This:C1470.dpiWidth/$originalDPIWidth)
						This:C1470.pointHeight:=(This:C1470.pixelHeight/This:C1470.dpiHeight)*72
						
					End if 
					
				End if 
				
				This:C1470.updateResultSize()
				
			End if 
			
			This:C1470.validate()
			
		: ($event.objectName="point_height")
			
			var $pointHeight : Real
			If ($event.code=On After Edit:K2:43)
				$pointHeight:=Num:C11(Get edited text:C655)
			Else 
				$pointHeight:=This:C1470.pointHeight
			End if 
			
			If ($pointHeight>0)
				
				If (This:C1470.resample)
					
					var $pixelHeight : Integer
					$pixelHeight:=($pointHeight*This:C1470.dpiHeight)/72
					This:C1470.pixelHeight:=$pixelHeight
					
					If ($event.code=On Data Change:K2:15)
						This:C1470.pointHeight:=(This:C1470.pixelHeight/This:C1470.dpiHeight)*72
					End if 
					
					C_POINTER:C301($propSizePtr)
					$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
					
					C_BOOLEAN:C305($propSize)
					$propSize:=($propSizePtr->=1)
					If ($propSize)
						
						C_REAL:C285($originalPixelWidth; $originalPixelHeight)
						$originalPixelWidth:=SizeObj_GetWidth(This:C1470.pixelSize)
						$originalPixelHeight:=SizeObj_GetHeight(This:C1470.pixelSize)
						
						This:C1470.pixelWidth:=$originalPixelWidth*($pixelHeight/$originalPixelHeight)
						This:C1470.pointWidth:=(This:C1470.pixelWidth/This:C1470.dpiWidth)*72
						
					End if 
					
				Else 
					
					This:C1470.dpiHeight:=(This:C1470.pixelHeight*72)/$pointHeight
					
					If ($event.code=On Data Change:K2:15)
						This:C1470.pointHeight:=(This:C1470.pixelHeight/This:C1470.dpiHeight)*72
					End if 
					
					C_POINTER:C301($propResPtr)
					$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
					
					C_BOOLEAN:C305($propRes)
					$propRes:=($propResPtr->=1)
					If ($propRes)
						
						C_REAL:C285($originalDPIWidth; $originalDPIHeight)
						$originalDPIWidth:=SizeObj_GetWidth(This:C1470.dpiSize)
						$originalDPIHeight:=SizeObj_GetHeight(This:C1470.dpiSize)
						
						This:C1470.dpiWidth:=$originalDPIWidth*(This:C1470.dpiHeight/$originalDPIHeight)
						This:C1470.pointWidth:=(This:C1470.pixelWidth/This:C1470.dpiWidth)*72
						
					End if 
					
				End if 
				
				This:C1470.updateResultSize()
				
			End if 
			
			This:C1470.validate()
			
		: ($event.objectName="dpi_width")
			
			var $dpiWidthh : Real
			
			If ($event.code=On After Edit:K2:43)
				$dpiWidthh:=Num:C11(Get edited text:C655)
			Else 
				$dpiWidthh:=This:C1470.dpiWidth
			End if 
			
			If ($dpiWidthh>0)
				
				If (True:C214)  //($resample)
					
					This:C1470.pointWidth:=(This:C1470.pixelWidth/$dpiWidthh)*72
					
					C_POINTER:C301($propResPtr)
					$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
					
					C_BOOLEAN:C305($propRes)
					$propRes:=($propResPtr->=1)
					If ($propRes)
						
						C_REAL:C285($originalDPIWidth; $originalDPIHeight)
						$originalDPIWidth:=SizeObj_GetWidth(This:C1470.dpiSize)
						$originalDPIHeight:=SizeObj_GetHeight(This:C1470.dpiSize)
						
						This:C1470.dpiHeight:=$originalDPIHeight*($dpiWidthh/$originalDPIWidth)
						This:C1470.pointHeight->:=(This:C1470.pixelHeight/This:C1470.dpiHeight)*72
						
					End if 
					
				Else 
					
				End if 
				
				This:C1470.updateResultSize()
				
			End if 
			
			This:C1470.validate()
			
		: ($event.objectName="dpi_height")
			
			var $dpiHeight : Real
			If ($event.code=On After Edit:K2:43)
				$dpiHeight:=Num:C11(Get edited text:C655)
			Else 
				$dpiHeight:=This:C1470.dpiHeight
			End if 
			
			If ($dpiHeight>0)
				
				If (True:C214)  //($resample)
					
					This:C1470.pointHeight:=(This:C1470.pixelHeight/$dpiHeight)*72
					
					C_POINTER:C301($propResPtr)
					$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
					
					C_BOOLEAN:C305($propRes)
					$propRes:=($propResPtr->=1)
					If ($propRes)
						
						C_REAL:C285($originalDPIWidth; $originalDPIHeight)
						$originalDPIWidth:=SizeObj_GetWidth(This:C1470.dpiSize)
						$originalDPIHeight:=SizeObj_GetHeight(This:C1470.dpiSize)
						
						This:C1470.dpiWidth:=$originalDPIWidth*($dpiHeight/$originalDPIHeight)
						This:C1470.pointWidth->:=(This:C1470.pixelWidth/This:C1470.dpiWidth)*72
						
					End if 
					
				Else 
					
				End if 
				
				This:C1470.updateResultSize()
				
			End if 
			
			This:C1470.validate()
			
		: ($event.objectName="prop_size")
			
			C_POINTER:C301($propSizePtr)
			$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
			If ($propSizePtr->>1)
				$propSizePtr->:=0
			End if 
			
			This:C1470.updateProportionalSizeState()
			
			If ($propSizePtr->=1)
				
				// Reset dims
				var $pixelWidth; $pixelHeight : Integer
				This:C1470.pixelWidth:=SizeObj_GetWidth(This:C1470.pixelSize)
				This:C1470.pixelHeight:=SizeObj_GetHeight(This:C1470.pixelSize)
				
				This:C1470.updateSizeValues()
				This:C1470.updateResultSize()
				
			End if 
			
			EDIT ITEM:C870(*; "resample")
			
		: ($event.objectName="prop_res")
			
			C_POINTER:C301($propResPtr)
			$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
			If ($propResPtr->>1)
				$propResPtr->:=0
			End if 
			
			This:C1470.updateProportionalResolutionState()
			
			If ($propResPtr->=1)
				
				// Reset res
				This:C1470.dpiWidth:=SizeObj_GetWidth(This:C1470.dpiSize)
				This:C1470.dpiHeight:=SizeObj_GetHeight(This:C1470.dpiSize)
				
				This:C1470.updateSizeValues()
				This:C1470.updateResolutionValues()
				This:C1470.updateResultSize()
				
			End if 
			
			EDIT ITEM:C870(*; "resample")
			
		: ($event.objectName="prop_both")
			
			var $propSizePtr; $propResPtr; $propBothPtr : Pointer
			$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
			$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
			$propBothPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_both")
			
			If ($propBothPtr->>1)
				$propBothPtr->:=0
			End if 
			$propSizePtr->:=$propBothPtr->
			$propResPtr->:=$propBothPtr->
			
			This:C1470.updateProportionalBothState()
			
			If ($propBothPtr->=1)
				
				// Reset dims
				This:C1470.pixelWidth:=SizeObj_GetWidth(This:C1470.pixelSize)
				This:C1470.pixelHeight:=SizeObj_GetHeight(This:C1470.pixelSize)
				
				// Reset res
				This:C1470.dpiWidth:=SizeObj_GetWidth(This:C1470.dpiSize)
				This:C1470.dpiHeight:=SizeObj_GetHeight(This:C1470.dpiSize)
				
				This:C1470.updateSizeValues()
				This:C1470.updateResolutionValues()
				This:C1470.updateResultSize()
				
			End if 
			
			EDIT ITEM:C870(*; "resample")
			
		: ($event.objectName="resample")
			
			If (This:C1470.resample)
				
				// Reset values
				This:C1470.reset()
				This:C1470.updateResultSize()
				
			Else 
				
				var $propSizePtr; $propResPtr; $propBothPtr : Pointer
				$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
				$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
				$propBothPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_both")
				
				var $propSize; $propRes : Boolean
				$propSize:=(($propSizePtr-> & 0x0001)#0)
				$propRes:=(($propResPtr-> & 0x0001)#0)
				
				If ($propSize | $propRes)
					$propBothPtr->:=1
				Else 
					$propBothPtr->:=0
				End if 
				
				// Reset dims
				This:C1470.pixelWidth:=SizeObj_GetWidth(This:C1470.pixelSize)
				This:C1470.pixelHeight:=SizeObj_GetHeight(This:C1470.pixelSize)
				
				This:C1470.updateResampleState()
				This:C1470.updateProportionalBothState()
				
				This:C1470.updateUnitsState()
				This:C1470.updateSizeValues()
				This:C1470.updateResolutionValues()
				
				This:C1470.updateResultSize()
				
			End if 
			
		: ($event.objectName="reset_button")
			
			This:C1470.reset()
			This:C1470.updateResultSize()
			
			EDIT ITEM:C870(*; "resample")
			
		: ($event.objectName="ok_button")
			
			This:C1470.pixelSize:=SizeObj_New(This:C1470.pixelWidth; This:C1470.pixelHeight)
			This:C1470.dpiSize:=SizeObj_New(This:C1470.dpiWidth; This:C1470.dpiHeight)
			
	End case 
	
	
Function reset()
	
	This:C1470.resample:=True:C214
	
	//This.proportionalSizeValue:=0x0001  // Locked/enabled
	//This.proportionalResolutionValue:=0x0001  // Locked/enabled
	//This.proportionalBothValue:=0x0000  // Unlocked/enabled
	
	var $propSizePtr; $propResPtr; $propBothPtr : Pointer
	$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
	$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
	$propBothPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_both")
	
	$propSizePtr->:=1  // Locked/enabled
	$propResPtr->:=1  // Locked/enabled
	$propBothPtr->:=0  // Unlocked/enabled
	
	This:C1470.pixelWidth:=SizeObj_GetWidth(This:C1470.pixelSize)
	This:C1470.pixelHeight:=SizeObj_GetHeight(This:C1470.pixelSize)
	
	This:C1470.dpiWidth:=SizeObj_GetWidth(This:C1470.dpiSize)
	This:C1470.dpiHeight:=SizeObj_GetHeight(This:C1470.dpiSize)
	
	
Function updateResampleState()
	
	OBJECT SET VISIBLE:C603(*; "prop_both"; Not:C34(This:C1470.resample))
	OBJECT SET VISIBLE:C603(*; "prop_both_line_@"; Not:C34(This:C1470.resample))
	OBJECT SET VISIBLE:C603(*; "prop_size"; This:C1470.resample)
	OBJECT SET VISIBLE:C603(*; "prop_res"; This:C1470.resample)
	
	
Function updateProportionalSizeState()
	
	If (This:C1470.resample)
		
		var $propSizePtr : Pointer
		$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
		
		C_BOOLEAN:C305($value; $enabled)
		$value:=(($propSizePtr-> & 0x0001)#0)
		$enabled:=(($propSizePtr-> & 0x0002)=0)
		//$value:=This.proportionalSizeState["locked"]
		//$enabled:=This.proportionalSizeState["enabled"]
		
		OBJECT SET RGB COLORS:C628(*; "prop_size_line_@"; \
			Choose:C955($value; 0x0000; 0x00FFFFFF); Choose:C955($value; 0x0000; 0x00FFFFFF))
		OBJECT SET ENABLED:C1123(*; "prop_size"; $enabled)
		
	End if 
	
	
Function updateProportionalResolutionState()
	
	If (This:C1470.resample)
		
		var $propResPtr : Pointer
		$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
		
		C_BOOLEAN:C305($value; $enabled)
		$value:=(($propResPtr-> & 0x0001)#0)
		$enabled:=(($propResPtr-> & 0x0002)=0)
		//$value:=This.proportionalResolutionState["locked"]
		//$enabled:=This.proportionalResolutionState["enabled"]
		
		OBJECT SET RGB COLORS:C628(*; "prop_res_line_@"; \
			Choose:C955($value; 0x0000; 0x00FFFFFF); Choose:C955($value; 0x0000; 0x00FFFFFF))
		OBJECT SET ENABLED:C1123(*; "prop_res"; $enabled)
		
	End if 
	
	
Function updateProportionalBothState()
	
	If (Not:C34(This:C1470.resample))
		
		var $propBothPtr : Pointer
		$propBothPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_both")
		
		C_BOOLEAN:C305($value; $enabled)
		$value:=($propBothPtr-> & 0x0001)#0
		$enabled:=($propBothPtr-> & 0x0002)=0
		//$value:=This.proportionalBothState["locked"]
		//$enabled:=This.proportionalBothState["enabled"]
		
		OBJECT SET RGB COLORS:C628(*; "prop_size_line_@"; \
			Choose:C955($value; 0x0000; 0x00FFFFFF); Choose:C955($value; 0x0000; 0x00FFFFFF))
		OBJECT SET RGB COLORS:C628(*; "prop_res_line_@"; \
			Choose:C955($value; 0x0000; 0x00FFFFFF); Choose:C955($value; 0x0000; 0x00FFFFFF))
		OBJECT SET RGB COLORS:C628(*; "prop_both_line_@"; \
			Choose:C955($value; 0x0000; 0x00FFFFFF); Choose:C955($value; 0x0000; 0x00FFFFFF))
		OBJECT SET ENABLED:C1123(*; "prop_both"; $enabled)
		
	End if 
	
	
Function updateUnitsState()
	
	var $currentUnits : Text
	$currentUnits:=This:C1470.unitsPopup.currentValue
	
	This:C1470.unitsPopup.values:=Choose:C955(This:C1470.resample; This:C1470.resampleUnits; This:C1470.noResampleUnits)
	This:C1470.unitsPopup.index:=This:C1470.unitsPopup.values.indexOf($currentUnits)
	This:C1470.unitsPopup.index:=Choose:C955(This:C1470.unitsPopup.index>=0; This:C1470.unitsPopup.index; 0)
	This:C1470.unitsPopup.currentValue:=This:C1470.unitsPopup.values[This:C1470.unitsPopup.index]
	
	This:C1470.unitsPopup:=This:C1470.unitsPopup  // Is this needed?
	
	
Function updateSizeValues()
	var $currentUnits : Text
	$currentUnits:=This:C1470.unitsPopup.currentValue
	
	var $pixelWidth; $pixelHeight : Integer
	var $dpiWidth; $dpiHeight : Real
	
	$pixelWidth:=This:C1470.pixelWidth
	$pixelHeight:=This:C1470.pixelHeight
	
	$dpiWidth:=This:C1470.dpiWidth
	$dpiHeight:=This:C1470.dpiHeight
	
	OBJECT SET VISIBLE:C603(*; "pixel_width"; False:C215)
	OBJECT SET VISIBLE:C603(*; "pixel_height"; False:C215)
	OBJECT SET VISIBLE:C603(*; "point_width"; False:C215)
	OBJECT SET VISIBLE:C603(*; "point_height"; False:C215)
	OBJECT SET VISIBLE:C603(*; "percent_width"; False:C215)
	OBJECT SET VISIBLE:C603(*; "percent_height"; False:C215)
	
	Case of 
		: ($currentUnits="Pixels")  // Pixels
			
			//$pixelWidthPtr->:=$pixelWidth
			//$pixelHeightPtr->:=$pixelHeight
			
			OBJECT SET VISIBLE:C603(*; "pixel_width"; True:C214)
			OBJECT SET VISIBLE:C603(*; "pixel_height"; True:C214)
			
		: ($currentUnits="Points")  // Points
			
			This:C1470.pointWidth:=($pixelWidth/$dpiWidth)*72
			This:C1470.pointHeight:=($pixelHeight/$dpiHeight)*72
			
			//$pointWidthPtr->:=$pointWidth
			//$pointHeightPtr->:=$pointHeight
			
			OBJECT SET VISIBLE:C603(*; "point_width"; True:C214)
			OBJECT SET VISIBLE:C603(*; "point_height"; True:C214)
			
		: ($currentUnits="Percent")  // Percent
			
			OBJECT SET VISIBLE:C603(*; "percent_width"; True:C214)
			OBJECT SET VISIBLE:C603(*; "percent_height"; True:C214)
			
	End case 
	
	
Function updateResolutionValues()
	
	var $dpiWidth; $dpiHeight : Real
	$dpiWidth:=This:C1470.dpiWidth
	$dpiHeight:=This:C1470.dpiHeight
	
	// Nothing to do
	
	
Function updateCurrentSize()
	
	var $pixelWidth; $pixelHeight : Integer
	$pixelWidth:=SizeObj_GetWidth(This:C1470.pixelSize)
	$pixelHeight:=SizeObj_GetHeight(This:C1470.pixelSize)
	
	var $dpiWidth; $dpiHeight : Real
	$dpiWidth:=SizeObj_GetWidth(This:C1470.dpiSize)
	$dpiHeight:=SizeObj_GetHeight(This:C1470.dpiSize)
	
	var $pointWidth; $pointHeight : Real
	$pointWidth:=($pixelWidth/$dpiWidth)*72
	$pointHeight:=($pixelHeight/$dpiHeight)*72
	
	C_TEXT:C284($dpiFormat; $pointFormat)
	$dpiFormat:="########0.0"
	$pointFormat:="########0.0"
	
	This:C1470.currentPixels:=String:C10($pixelWidth)+" x "+String:C10($pixelHeight)+" pixels"
	This:C1470.currentPoints:=String:C10($pointWidth; $pointFormat)+" x "+String:C10($pointHeight; $pointFormat)+" points"
	This:C1470.currentDPI:=String:C10($dpiWidth; $dpiFormat)+" x "+String:C10($dpiHeight; $dpiFormat)+" DPI"
	
	
Function updateResultSize()
	
	var $pixelWidth; $pixelHeight : Integer
	$pixelWidth:=This:C1470.pixelWidth
	$pixelHeight:=This:C1470.pixelHeight
	
	var $dpiWidth; $dpiHeight : Real
	$dpiWidth:=This:C1470.dpiWidth
	$dpiHeight:=This:C1470.dpiHeight
	
	var $pointWidth; $pointHeight : Real
	$pointWidth:=($pixelWidth/$dpiWidth)*72
	$pointHeight:=($pixelHeight/$dpiHeight)*72
	
	C_TEXT:C284($dpiFormat; $pointFormat)
	$dpiFormat:="########0.0"
	$pointFormat:="########0.0"
	
	This:C1470.resultPixels:=String:C10($pixelWidth)+" x "+String:C10($pixelHeight)+" pixels"
	This:C1470.resultPoints:=String:C10($pointWidth; $pointFormat)+" x "+String:C10($pointHeight; $pointFormat)+" points"
	This:C1470.resultDPI:=String:C10($dpiWidth; $dpiFormat)+" x "+String:C10($dpiHeight; $dpiFormat)+" DPI"
	
	
Function validate()
	
	var $valid : Boolean
	$valid:=((This:C1470.pixelWidth>0) & (This:C1470.pixelHeight>0) & (This:C1470.dpiWidth>=1) & (This:C1470.dpiHeight>=1))
	
	OBJECT SET ENABLED:C1123(*; "ok_button"; $valid)
	
	
	