//%attributes = {"shared":true}
C_LONGINT:C283($1;$areaRef)  // @param: The image area reference.
C_OBJECT:C1216($0;$pointSelection)  // @param: The image area pixel selection rectangle.

  // @desc: Return the marquee point selection rectangle of a plug-in area.

  // @doc: Return the marquee point selection rectangle of a plug-in area.
  //
  // Parameter ``areaRef`` is the plug-in area reference.
  //
  // The selection rectangle is returned in ``pointSelection`` as a ``RectObj``
  // expressed in points.
  // 
  // If the plug-in area is currently displaying a raster document, the pixel selection
  // rectangle can be retrieved as well with a call to
  // :cc4d:cmethod:`ImgArea_GetPixelSelection`.
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:cmethod:`ImgArea_GetSelection` method.

ASSERT:C1129(Count parameters:C259=1)

$areaRef:=$1

C_OBJECT:C1216($selection)
$selection:=ImgArea_GetSelection ($areaRef)
If (OB Is defined:C1231($selection;"PointSelection"))
	$pointSelection:=OB Get:C1224($selection;"PointSelection";Is object:K8:27)
End if 

$0:=$pointSelection
