//%attributes = {"shared":true}
C_LONGINT:C283($1;$areaRef)  // @param: The image area reference.
C_OBJECT:C1216($0;$selection)  // @param: The image area selection rectangle.

  // @desc: Return the marquee selection rectangle of a plug-in area.

  // @doc: Return the marquee selection rectangle of a plug-in area.
  //
  // Parameter ``areaRef`` is the plug-in area reference.
  //
  // The selection rectangle is returned in ``selection`` as a 4D object
  // containing the following properties:
  // 
  // .. list-table::
  //    :widths: 20 20 60
  //    :header-rows: 1
  // 
  //    * - Property name
  //      - Type
  //      - Description
  //    * - ``PointSelection``
  //      - ``RectObj``
  //      - The marquee selection rectangle expressed in *points*.
  //    * - ``PixelSelection``
  //      - ``RectObj``
  //      - The marquee selection rectangle expressed in *pixels*.
  //        
  //        Present only when the plug-in area displays a raster image.
  //
  // If there is no marquee selection, an undefined object is returned.
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:xmethod:`ImgArea_GetSelection_JSN` plug-in method.

ASSERT:C1129(Count parameters:C259=1)

$areaRef:=$1

C_TEXT:C284($selectionJSON)
$selectionJSON:=ImgArea_GetSelection_JSN:P11667:52 ($areaRef)
If ($selectionJSON#"")
	JSON_Parse (->$selectionJSON;->$selection)
End if 

$0:=$selection
