//%attributes = {"shared":true}
C_LONGINT:C283($1;$areaRef)  // @param: The image area reference.
C_OBJECT:C1216($2;$pointSelection)  // @param: The image area point selection rectangle.

  // @desc: Set the marquee point selection rectangle of a plug-in area.

  // @doc: Set the marquee point selection rectangle of a plug-in area.
  //
  // Parameter ``areaRef`` is the plug-in area reference.
  //
  // The selection rectangle is specified in ``pointSelection`` as a ``RectObj``
  // expressed in points.
  // 
  // If the plug-in area is currently displaying a raster document, the pixel selection
  // rectangle can be set as well with a call to
  // :cc4d:cmethod:`ImgArea_SetPixelSelection`.
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:cmethod:`ImgArea_SetSelection` method.

ASSERT:C1129(Count parameters:C259>=1)

$areaRef:=$1
If (Count parameters:C259>1)
	$pointSelection:=$2
End if 

C_OBJECT:C1216($selection)
OB SET:C1220($selection;"PointSelection";$pointSelection)

ImgArea_SetSelection ($areaRef;$selection)
