//%attributes = {"shared":true}
C_LONGINT:C283($1;$areaRef)  // @param: The image area reference.
C_OBJECT:C1216($2;$selection)  // @param: The image area selection rectangle.

  // @desc: Change the marquee selection rectangle.

  // @doc: Change the marquee selection rectangle of a plug-in area.
  //
  // Parameter ``areaRef`` is the plug-in area reference.
  //
  // The selection rectangle is specified in ``selection`` as a 4D object
  // containing any of the following properties:
  // 
  // .. list-table::
  //    :widths: 20 20 60
  //    :header-rows: 1
  // 
  //    * - Property name
  //      - Type
  //      - Description
  //    * - ``PointSelection``
  //      - ``RectObj``
  //      - The marquee selection rectangle expressed in *points*.
  //    * - ``PixelSelection``
  //      - ``RectObj``
  //      - The marquee selection rectangle expressed in *pixels*.
  //        
  //        Present only when the plug-in area displays a raster image.
  //
  // If ``selection`` is an undefined object or omitted the marquee selection is cleared.
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:xmethod:`ImgArea_SetSelection_JSN` plug-in method.

ASSERT:C1129(Count parameters:C259>=1)

$areaRef:=$1
If (Count parameters:C259>1)
	$selection:=$2
End if 

C_TEXT:C284($selectionJSON)
If (OB Is defined:C1231($selection))
	$selectionJSON:=JSON Stringify:C1217($selection)
End if 

ImgArea_SetSelection_JSN:P11667:53 ($areaRef;$selectionJSON)
