//%attributes = {"shared":true}
C_POINTER:C301($1;$pixelSizePtr)  // @param: Pointer to the raster frame pixel size.
C_POINTER:C301($2;$dpiSizePtr)  // @param: Pointer to the raster frame resolution.
C_LONGINT:C283($0;$success)  // @param: Completion status: ``1`` on success, ``0`` otherwise.

  // @desc: Display a dialog where the user can adjust the size of a raster frame.

  // @doc: Display a dialog where the user can adjust the size of a raster frame
  // by changing the pixel size and/or resolution.
  // 
  // Parameters ``pixelSizePtr`` and ``dpiSizePtr`` are both pointers to ``SizeObj`` objects.
  // On entry, the two ``SizeObj`` objects specify the current pixel size and resolution
  // respectively. On successful completion they will contain the new values entered
  // by the user.
  // 
  // If the user accepts the dialog, ``1`` is returned in ``success``, ``0`` otherwise.
  //

ASSERT:C1129(Count parameters:C259=2)

$pixelSizePtr:=$1
$dpiSizePtr:=$2
$success:=0

ASSERT:C1129(Not:C34(Is nil pointer:C315($pixelSizePtr)))
ASSERT:C1129(Type:C295($pixelSizePtr->)=Is object:K8:27)

ASSERT:C1129(Not:C34(Is nil pointer:C315($dpiSizePtr)))
ASSERT:C1129(Type:C295($dpiSizePtr->)=Is object:K8:27)

C_OBJECT:C1216($pixelSize;$dpiSize)
$pixelSize:=$pixelSizePtr->
$dpiSize:=$dpiSizePtr->

C_LONGINT:C283($pixelWidth;$pixelHeight)
$pixelWidth:=SizeObj_GetWidth ($pixelSize)
$pixelHeight:=SizeObj_GetHeight ($pixelSize)

C_REAL:C285($dpiWidth;$dpiHeight)
$dpiWidth:=SizeObj_GetWidth ($dpiSize)
$dpiHeight:=SizeObj_GetHeight ($dpiSize)

If (($pixelWidth>0) & ($pixelHeight>0) & ($dpiWidth>=1) & ($dpiHeight>=1))
	
	C_OBJECT:C1216(pPixelSize;pDPISize)
	pPixelSize:=SizeObj_New ($pixelWidth;$pixelHeight)
	pDPISize:=SizeObj_New ($dpiWidth;$dpiHeight)
	
	C_LONGINT:C283(pSizeWindow)
	pSizeWindow:=Open form window:C675("_RasterSize";Movable form dialog box:K39:8;Horizontally centered:K39:1;Vertically centered:K39:4)
	SET WINDOW TITLE:C213("Adjust image size";pSizeWindow)
	DIALOG:C40("_RasterSize")
	If (OK=1)
		
		$pixelSizePtr->:=OB Copy:C1225(pPixelSize)
		$dpiSizePtr->:=OB Copy:C1225(pDPISize)
		
		$success:=1
		
	End if 
	CLOSE WINDOW:C154(pSizeWindow)
	
End if 

$0:=$success

