//%attributes = {"shared":true}
C_OBJECT:C1216($1;$errInfo)  // @param: The Q2Pix error info for the current process.

  // @desc: Set the Q2Pix error info for the current process.

  // @doc: Set the Q2Pix error info for the current process.
  //
  // The error info is specified in ``errInfo``, a 4D object that contains the following properties:
  //
  // .. include:: /_shared/ImgErr_Info.rsti
  //
  // This method is primarily for use by components or code modules built around Q2Pix in order to communicate error
  // information to their callers using the same mechanism.
  //
  // .. note:: This method is a wrapper for the :cc4d:xmethod:`ImgErr_SetInfo_JSN` plug-in method.
  //

$errInfo:=$1

If (OB Is defined:C1231($errInfo))
	
	C_TEXT:C284($errInfoJSON)
	$errInfoJSON:=JSON Stringify:C1217($errInfo)
	
	ImgErr_SetInfo_JSN:P11667:147 ($errInfoJSON)
	
End if 
