//%attributes = {"shared":true}
C_TEXT:C284($1;$formatID)  // @param: The image format identifier.
C_OBJECT:C1216($0;$infoObj)  // @param: The image format information object.

  // @desc: Return the image format's characteristics.

  // @doc: Return the image format's characteristics as a 4D object.
  // 
  // Parameter ``formatID`` is the identifier of the image format. If ``formatID``
  // is not a valid image format identifier or empty, an undefined object is returned.
  //
  // Some common image format identifiers are "JPEG", "TIFF", "PNG", "PDF, and so on.
  // The list of supported format identifiers can be retrieved with the
  // :cc4d:xmethod:`ImgFormat_GetList` plug-in method.
  //
  // The contents of object ``infoObj`` that receives the image format characteristics
  // are described in the following table.
  //
  // .. include:: /_shared/ImgFormat_Info.rsti
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:xmethod:`ImgFormat_GetInfo_JSN`
  //           plug-in method.
  //

ASSERT:C1129(Count parameters:C259=1)

$formatID:=$1

C_TEXT:C284($json)
$json:=ImgFormat_GetInfo_JSN:P11667:143 ($formatID)
If ($json#"")
	$infoObj:=JSON Parse:C1218($json;Is object:K8:27)
End if 

$0:=$infoObj
