//%attributes = {"shared":true}
C_POINTER:C301($1;$formatArrayPtr)  // @param: List of format IDs. @optional
C_TEXT:C284($0;$utiFilter)  // @param: The UTI filter.

  // @desc: Returns a UTI filter string.

  // @doc: Returns a UTI filter string suitable
  // for passing to the **Select document** 4D command.
  // 
  // By default the filter strings contains UTIs for all
  // supported formats.
  //
  // To get a filter string for a subset of the supported formats,
  // pass in ``formatArrayPtr`` a pointer to a text array containing
  // the format IDs.


ASSERT:C1129(Count parameters:C259<=1)

If (Count parameters:C259>0)
	$formatArrayPtr:=$1
End if 

$utiFilter:=""

ARRAY TEXT:C222($formatIDs;0)
If (Not:C34(Is nil pointer:C315($formatArrayPtr)))
	COPY ARRAY:C226($formatArrayPtr->;$formatIDs)
Else 
	ImgFormat_GetList:P11667:142 ($formatIDs)
End if 

C_LONGINT:C283($formatCount)
$formatCount:=Size of array:C274($formatIDs)

C_LONGINT:C283($idx)

For ($idx;1;$formatCount)
	
	C_OBJECT:C1216($formatInfo)
	$formatInfo:=ImgFormat_GetInfo ($formatIDs{$idx})
	
	If (OB Is defined:C1231($formatInfo))
		
		C_TEXT:C284($uti)
		$uti:=OB Get:C1224($formatInfo;"UTI";Is text:K8:3)
		
		If ($uti#"")
			$utiFilter:=$utiFilter+";"+$uti
		End if 
		
	End if 
	
End for 

If ($utiFilter#"")  // Strip leading ";"
	$utiFilter:=Substring:C12($utiFilter;2)
End if 

$0:=$utiFilter
