//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The image document reference.
C_LONGINT:C283($2;$frameIdx)  // @param: The index of the image frame. @optional
C_OBJECT:C1216($3;$options)  // @param: Thumbnail creation and encoding options. @optional
C_BLOB:C604($0;$thumb)  // @param: The thumbnail data.

  // @desc: Create a thumbnail from an image frame and return it as a BLOB.

  // @doc: Create a thumbnail from an image frame.
  //
  // The thumbnail image is returned as a BLOB. To convert the BLOB to a 4D picture,
  // call BLOB TO PICTURE, or call directly :cc4d:cmethod:`ImgFrame_CreateThumbPicture`
  // which is a convenience wrapper for this method.
  //
  // If the method call fails for some reason, an empty BLOB is returned and the
  // Q2Pix :ref:`error info <ImgErr_GetInfo>` is set accordingly.
  //
  // Parameter ``imgDocRef`` is the image document reference. This method works with both raster
  // images and PDF documents.
  //
  // Parameter ``frameIdx`` is the index of the image frame. Passing ``0`` or omitting this
  // parameter is the same as passing 1.
  //
  // The ``options`` 4D object may contain the following properties:
  //
  // .. include:: /_shared/Thumbnail_Creation_Options.rsti
  //
  // .. include:: /_shared/Thumbnail_Encoding_Options.rsti
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:xmethod:`ImgFrame_CreateThumb_JSN`
  //           plug-in method.
  //

ASSERT:C1129(Count parameters:C259>=1)

$imgDocRef:=$1
If (Count parameters:C259>1)
	$frameIdx:=$2
End if 
If (Count parameters:C259>2)
	$options:=$3
End if 

If ($frameIdx=0)
	$frameIdx:=1
End if 

C_TEXT:C284($optionsJSON)
If (OB Is defined:C1231($options))
	$optionsJSON:=JSON Stringify:C1217($options)
End if 

$thumb:=ImgFrame_CreateThumb_JSN:P11667:24 ($imgDocRef;$frameIdx;$optionsJSON)

$0:=$thumb

