//%attributes = {"shared":true}
C_TEXT:C284($1;$sourceID)  // @param: The image source ID.
C_OBJECT:C1216($2;$options)  // @param: Acquisition options. @optional
C_OBJECT:C1216($0;$results)  // @param: The acquisition results.

  // @desc: Run an image acquisition session.

  // @doc: Run an image acquisition session and return the acquisition results as an object.
  //
  // Parameter ``sourceID`` is the ID of the image source.
  //
  // The optional parameter ``options`` is a 4D object that can used to specify options
  // for the acquisition session:
  //
  // .. include:: /_shared/ImgSource_Acquire_Options.rsti
  //
  // The results of a successful acquisition session are returned in ``results`` in the form of a 4D object.
  //
  // The ``results`` object will contain the following properties:
  //
  // .. include:: /_shared/ImgSrc_Results.rsti
  //
  // .. note:: This method is a wrapper for the :cc4d:xmethod:`ImgSrc_Acquire_JSN` plug-in method.
  //           It accepts and returns 4D objects instead JSON object serializations.

ASSERT:C1129(Count parameters:C259>=1)

$sourceID:=$1
If (Count parameters:C259>1)
	$options:=$2
End if 

C_TEXT:C284($optionsJSON;$resultsJSON)
If (OB Is defined:C1231($options))
	$optionsJSON:=JSON Stringify:C1217($options)
End if 

$resultsJSON:=ImgSource_Acquire_JSN:P11667:126 ($sourceID;$optionsJSON)
If ($resultsJSON#"")
	JSON_Parse (->$resultsJSON;->$results)
End if 

$0:=$results

