//%attributes = {"shared":true}
C_TEXT:C284($1;$protocol)  // @param: Restrict image sources to this protocol. @optional
C_OBJECT:C1216($0;$sourceList)  // @param: The result image source list represented by a 4D object.

  // @desc: Return the available image acquisition sources.

  // @doc: Return a list of the available image acquisition sources as a 4D object.
  //
  // Parameter ``protocol`` is optional. If present, only the sources available via the specified protocol are returned.
  // 
  // .. include:: /_shared/ImgSrc_Protocol.rsti
  //
  // The list of image sources is returned as a 4D object.
  //
  // The names of the properties in the returned object are the ID's of the sources.
  // The value of each property is an object containing information about the source.
  // The properties of the source information object are described in the following table.
  // 
  // .. include:: /_shared/ImgSrc_Info.rsti
  //
  // .. note:: This method is a wrapper for the :cc4d:xmethod:`ImgSrc_GetList_JSN` plug-in method.
  //           It returns a 4D object instead of a JSON object serialization.


If (Count parameters:C259>0)
	$protocol:=$1
End if 

C_TEXT:C284($sourceListJSON)
$sourceListJSON:=ImgSource_GetList_JSN:P11667:125 ($protocol)
If ($sourceListJSON#"")
	JSON_Parse (->$sourceListJSON;->$sourceList)
End if 

$0:=$sourceList
