//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The raster document reference.
C_LONGINT:C283($2;$frameIdx)  // @param: The index of the image frame. @optional
C_OBJECT:C1216($3;$options)  // @param: Thumbnail extraction and encoding options. @optional
C_BLOB:C604($0;$thumb)  // @param: The thumbnail data.

  // @desc: Extract the embedded thumbnail from a raster frame and return it as a BLOB.

  // @doc: Extract the embedded thumbnail from a raster frame, if one exists.
  //
  // The thumbnail image is returned as a BLOB. To convert the BLOB to a 4D picture,
  // call BLOB TO PICTURE, or call directly :cc4d:cmethod:`RasterFrame_GetEmbThumbPict`
  // which is a convenience wrapper for this method.
  //
  // Parameter ``imgDocRef`` is the raster document reference.
  //
  // Parameter ``frameIdx`` is the index of the image frame. Passing ``0`` or omitting this
  // parameter is the same as passing 1.
  //
  // The ``options`` 4D object may contain the following properties:
  //
  // .. include:: /_shared/Thumbnail_Extraction_Options.rsti
  // .. include:: /_shared/Thumbnail_Encoding_Options.rsti
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:xmethod:`RasterFrame_GetEmbThumb_JSN`
  //           plug-in method.
  //

ASSERT:C1129(Count parameters:C259>=1)

$imgDocRef:=$1
If (Count parameters:C259>1)
	$frameIdx:=$2
End if 
If (Count parameters:C259>2)
	$options:=$3
End if 

If ($frameIdx=0)
	$frameIdx:=1
End if 

C_TEXT:C284($optionsJSON)
If (OB Is defined:C1231($options))
	$optionsJSON:=JSON Stringify:C1217($options)
End if 

$thumb:=RasterFrame_GetEmbThumb_JSN:P11667:26 ($imgDocRef;$frameIdx;$optionsJSON)

$0:=$thumb

