//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The raster document reference.
C_LONGINT:C283($2;$frameIdx)  // @param: The index of the raster frame.
C_LONGINT:C283($3;$orientation)  // @param: The raster frame's orientation.

  // @desc: Change the orientation of a raster frame.

  // @doc: Change the orientation property of the raster frame specified with ``imgDocRef`` and ``frameIdx``.
  //
  // Parameter ``imgDocRef`` is the raster document reference. If ``imgDocRef`` refers
  // to a PDF document, this method does nothing.
  //
  // Parameter ``frameIdx`` is the index of the raster frame.
  //
  // The frame's orientation is specified by ``orientation`` and must be set to a value defined
  // by the "Image Orientation" constants. Passing an invalid value will set the Q2Pix :ref:`error info <error-info>`
  // to ``"POSIX"``/``kPOSIXErrInval``.
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:cmethod:`RasterFrame_PushFilter` method
  //           that pushes the ``Orientation`` filter into the raster frame's edit stack.
  //

ASSERT:C1129(Count parameters:C259=3)

$imgDocRef:=$1
$frameIdx:=$2
$orientation:=$3

C_OBJECT:C1216($filterParams)
OB SET:C1220($filterParams;"Orientation";$orientation)

RasterFrame_PushFilter ($imgDocRef;$frameIdx;"Orientation";$filterParams)
