//%attributes = {"shared":true}
C_OBJECT:C1216($1;$rectObj)  // @param: The ``RectObj`` object.
C_OBJECT:C1216($0;$origin)  // @param: The rect's origin.

  // @desc: Return the rect's origin.

  // @doc: Return the rect's origin.
  //
  // The ``RectObj`` object is passed in the ``rectObj`` parameter.
  //
  // The rect's origin is returned in ``origin`` as a ``PointObj`` object.
  //

ASSERT:C1129(Count parameters:C259=1)

$rectObj:=$1

ASSERT:C1129(OB Is defined:C1231($rectObj;"X"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Y"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Width"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Height"))

C_REAL:C285($x;$y)
$x:=OB Get:C1224($rectObj;"X";Is real:K8:4)
$y:=OB Get:C1224($rectObj;"Y";Is real:K8:4)

$origin:=PointObj_New ($x;$y)

$0:=$origin
