//%attributes = {"shared":true}
C_OBJECT:C1216($1;$rectObj)  // @param: The ``RectObj`` object.
C_REAL:C285($0;$y)  // @param: The Y coordinate of ``pointObj``'s origin.

  // @desc: Return the Y coordinate of the origin of a RectObj object.

  // @doc: Return the Y coordinate of the origin of a ``RectObj`` object.
  //
  // The ``RectObj`` object is passed in the ``rectObj`` parameter.
  //
  // The Y coordinate of ``rectObj``'s origin is returned in ``Y``.
  //

ASSERT:C1129(Count parameters:C259=1)

$rectObj:=$1
$y:=0

ASSERT:C1129(OB Is defined:C1231($rectObj;"X"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Y"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Width"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Height"))

$y:=OB Get:C1224($rectObj;"Y";Is real:K8:4)

$0:=$y
