//%attributes = {}
C_OBJECT:C1216($dialogSpec)
$dialogSpec:=_RasterEffect_GetDialogSpec

C_OBJECT:C1216($effectDefs)
$effectDefs:=_RasterEffect_GetDefs

C_OBJECT:C1216($dialogEffects)
$dialogEffects:=OB Get:C1224($dialogSpec; "Effects"; Is object:K8:27)

C_OBJECT:C1216(pDialogEffects)
pDialogEffects:=New object:C1471()

ARRAY TEXT:C222($effectNames; 0)
OB GET PROPERTY NAMES:C1232($dialogEffects; $effectNames)

C_LONGINT:C283($idx; $count)
$count:=Size of array:C274($effectNames)

ARRAY TEXT:C222(pEffectNames; 0)
ARRAY TEXT:C222(pEffectTitles; 0)

For ($idx; 1; $count)
	
	C_TEXT:C284($name)
	$name:=$effectNames{$idx}
	
	If (OB Is defined:C1231($effectDefs; $name))
		
		C_OBJECT:C1216($def)
		$def:=OB Get:C1224($effectDefs; $name; Is object:K8:27)
		
		C_TEXT:C284($title)
		$title:=OB Get:C1224($def; "Title"; Is text:K8:3)
		
		APPEND TO ARRAY:C911(pEffectNames; $name)
		APPEND TO ARRAY:C911(pEffectTitles; $title)
		
		C_OBJECT:C1216($spec)
		$spec:=OB Get:C1224($dialogEffects; $name; Is object:K8:27)
		$spec:=OB_SimpleMerge($spec; $def)
		
		C_OBJECT:C1216($paramDefaults)
		$paramDefaults:=New object:C1471()
		
		C_OBJECT:C1216($paramDefs)
		$paramDefs:=OB Get:C1224($spec; "Params"; Is object:K8:27)
		
		ARRAY TEXT:C222($paramNames; 0)
		OB GET PROPERTY NAMES:C1232($paramDefs; $paramNames)
		
		C_LONGINT:C283($paramIdx; $paramCount)
		$paramCount:=Size of array:C274($paramNames)
		
		For ($paramIdx; 1; $paramCount)
			
			C_TEXT:C284($paramName)
			$paramName:=$paramNames{$paramIdx}
			
			C_OBJECT:C1216($paramDef)
			$paramDef:=OB Get:C1224($paramDefs; $paramName; Is object:K8:27)
			
			If (OB Is defined:C1231($paramDef; "Default"))
				
				C_LONGINT:C283($defaultType)
				$defaultType:=OB Get type:C1230($paramDef; "Default")
				
				Case of 
					: (($defaultType=Is real:K8:4) | ($defaultType=Is longint:K8:6))
						
						C_REAL:C285($realVal)
						$realVal:=OB Get:C1224($paramDef; "Default"; Is real:K8:4)
						
						OB SET:C1220($paramDefaults; $paramName; $realVal)
						
					: ($identityType=Is boolean:K8:9)
						
						C_BOOLEAN:C305($boolVal)
						$boolVal:=OB Get:C1224($paramDef; "Default"; Is boolean:K8:9)
						
						OB SET:C1220($paramDefaults; $paramName; $boolVal)
						
				End case 
				
			Else 
				
				If (OB Is defined:C1231($paramDef; "Identity"))
					
					C_LONGINT:C283($identityType)
					$identityType:=OB Get type:C1230($paramDef; "Identity")
					
					Case of 
						: (($identityType=Is real:K8:4) | ($identityType=Is longint:K8:6))
							
							C_REAL:C285($realVal)
							$realVal:=OB Get:C1224($paramDef; "Identity"; Is real:K8:4)
							
							OB SET:C1220($paramDefaults; $paramName; $realVal)
							
						: ($identityType=Is boolean:K8:9)
							
							C_BOOLEAN:C305($boolVal)
							$boolVal:=OB Get:C1224($paramDef; "Identity"; Is boolean:K8:9)
							
							OB SET:C1220($paramDefaults; $paramName; $boolVal)
							
					End case 
					
				End if 
				
			End if 
			
		End for 
		
		C_OBJECT:C1216($paramValues)
		$paramValues:=OB Copy:C1225($paramDefaults)
		
		OB SET:C1220($spec; "ParamValues"; $paramValues; "ParamDefaults"; $paramDefaults)
		
		OB SET:C1220(pDialogEffects; $name; $spec)
		
	End if 
	
End for 

SORT ARRAY:C229(pEffectTitles; pEffectNames; >)
