C_POINTER:C301($srcPathPtr)
$srcPathPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_path")

If (Size of array:C274($srcPathPtr->)>0)
	
	ARRAY TEXT:C222($formatIDs; 2)
	$formatIDs{1}:="PDF"
	$formatIDs{2}:="TIFF"
	
	C_OBJECT:C1216($savingOptions)
	OB SET:C1220($savingOptions; "Format"; "PDF")
	
	If (ImgDlog_SavingOptions(""; ->$savingOptions; ->$formatIDs)=1)
		
		
		C_TEXT:C284($destFormat)
		$destFormat:=OB Get:C1224($savingOptions; "Format"; Is text:K8:3)
		
		C_DATE:C307($today)
		C_TIME:C306($now)
		$today:=Current date:C33
		$now:=Current time:C178
		
		C_TEXT:C284($defaultName)
		$defaultName:=\
			String:C10(Year of:C25($today); "0000")\
			+"-"+String:C10(Month of:C24($today); "00")\
			+"-"+String:C10(Day of:C23($today); "00")\
			+"_"+Replace string:C233(String:C10($now; HH MM SS:K7:1); ":"; "-")\
			+"."+Choose:C955($destFormat="TIFF"; "tiff"; "pdf")
		
		ARRAY TEXT:C222($selectedFilePaths; 0)
		C_TEXT:C284($selectedFileName)
		
		$selectedFileName:=Select document:C905($defaultName; "*.*"; "Save merged image"; File name entry:K24:17; $selectedFilePaths)
		If ($selectedFileName#"")
			
			C_TEXT:C284($destPOSIXPath)
			$destPOSIXPath:=Convert path system to POSIX:C1106($selectedFilePaths{1})
			
			C_LONGINT:C283($success)
			$success:=0
			
			C_LONGINT:C283(_pMergerProgress)
			_pMergerProgress:=Progress New
			Progress SET PROGRESS(_pMergerProgress; -1)
			Progress SET TITLE(_pMergerProgress; "Preparing images for merging...")
			Progress SET BUTTON TITLE(_pMergerProgress; "Stop")
			Progress SET BUTTON ENABLED(_pMergerProgress; False:C215)
			Progress SET WINDOW VISIBLE(True:C214; -1; -1; True:C214)
			
			
			C_TEXT:C284($destDocRef)
			$destDocRef:=ImgDoc_CreateNew($savingOptions)
			
			C_LONGINT:C283($fileIdx; $frameIdx)
			
			For ($fileIdx; 1; Size of array:C274($srcPathPtr->))
				
				C_TEXT:C284($srcDocRef)
				$srcDocRef:=ImgDoc_CreateWithFile($srcPathPtr->{$fileIdx})
				If ($srcDocRef#"")
					
					C_LONGINT:C283($srcFrameCount)
					$srcFrameCount:=ImgDoc_GetFrameCount:P11667:11($srcDocRef)
					
					For ($frameIdx; 1; $srcFrameCount)
						
						ImgDoc_InsertFrame($destDocRef; \
							ImgDoc_GetFrameCount:P11667:11($destDocRef)+1; \
							$srcDocRef; $frameIdx)
						
					End for 
					
					ImgObj_Release:P11667:133($srcDocRef)
				End if 
				
				C_REAL:C285($progress)
				$progress:=$fileIdx/Size of array:C274($srcPathPtr->)
				
				Progress SET PROGRESS(_pMergerProgress; $progress)
				
			End for 
			
			Progress SET TITLE(_pMergerProgress; "Merging images...")
			
			OB SET:C1220($savingOptions; "Attach"; False:C215)
			OB SET:C1220($savingOptions; "ProgressCallback"; "ImageMerger__Progress")
			
			$success:=ImgDoc_SaveInFile($destDocRef; $destPOSIXPath; $savingOptions)
			
			Progress QUIT(_pMergerProgress)
			_pMergerProgress:=0
			
			ImgObj_Release:P11667:133($destDocRef)
			
			If ($success=1)
				
				C_TEXT:C284($archivePath)
				$archivePath:=Archive_GetDirPath
				If ($destPOSIXPath=($archivePath+"/"+"@"))
					
					C_OBJECT:C1216($message)
					OB SET:C1220($message; "What"; "Refresh"; "Path"; $archivePath)
					ArchiveBrowser_PostMessage($message)
					
				End if 
				
				C_OBJECT:C1216($args)
				OB SET:C1220($args; "Path"; $destPOSIXPath)
				
				ImgControl_Viewer("Open"; $args)
				
			End if 
			
		End if 
		
		
	End if 
	
End if 
